---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 11.06.2021 16:12
---

local AddonName, BohemkaDKP = ...
local LibDeflate = LibStub:GetLibrary("LibDeflate")
local LibSerialize = LibStub("LibSerialize")

BohemkaDKPConfig = {
    timerColors = {
        { 60, {r = 0, g = 0.6, b = 0.1}},
        { 40, {r = 0.9, g = 0.7, b = 0}},
        { 20, {r = 0.75, g = 0.27, b = 0}},
        { 0, {r = 0.8, g = 0.3, b = 0.22}},
    },
    timerMax = 10,
    minItemPrice = 20,
    channel = "RAID",
    bidCooldown = 1,
    minBid = 10,
    startingDKP = 100,
    bossRewards = {},
    itemPrices = {},
    debug = false,
    showDKP = true,
    showProfessions = true,
    autoBackup = 24,
    bench = {},
    benchSize = 10,
    showCharNameInChat = true,
    startAuctionModifier = "ALT",
    showOwnReagents = true,
    showOfflineMembers = true,
    collapsed = {}
}
CurrentDKPLog = {}
DKPLog = {}
RosterData = {
    professions = {},
    talents = {},
    characters = {},
}
AccountData = {
    characters = {}
}
Crafts = {

}

BohemkaDKP.currentTime = BohemkaDKPConfig.timerMax
BohemkaDKP.lastShareTime = 0
BohemkaDKP.chunks = {}
BohemkaDKP.chunksToSend = {}

BohemkaDKP.REQUIRED_ADDONS = {
    [AddonName] = false,
}

BohemkaDKP.UNCOMPATIBLE_ADDONS = {
}


local EventFrame = CreateFrame('Frame')
EventFrame:RegisterEvent('ADDON_LOADED')
EventFrame:RegisterEvent('GUILD_ROSTER_UPDATE')
EventFrame:RegisterEvent('CHAT_MSG_ADDON')
EventFrame:RegisterEvent('GET_ITEM_INFO_RECEIVED')
EventFrame:RegisterEvent('CHAT_MSG_SKILL')
EventFrame:RegisterEvent('CHAT_MSG_RAID')
EventFrame:RegisterEvent('CHAT_MSG_GUILD')
EventFrame:RegisterEvent('CHAT_MSG_PARTY')
EventFrame:RegisterEvent('CHAT_MSG_PARTY_LEADER')
EventFrame:RegisterEvent('CHAT_MSG_RAID_LEADER')
EventFrame:RegisterEvent('CHAT_MSG_WHISPER')
EventFrame:RegisterEvent('PLAYER_ENTERING_WORLD')
EventFrame:RegisterEvent('GROUP_ROSTER_UPDATE')
EventFrame:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
EventFrame:RegisterEvent('LOOT_OPENED')
EventFrame:RegisterEvent('PLAYER_LOGOUT')
EventFrame:RegisterEvent('CRAFT_UPDATE')
EventFrame:RegisterEvent('TRADE_SKILL_UPDATE')
BohemkaDKP:CheckCompatibility()

BohemkaDKP.EventFrame = EventFrame;
if BohemkaDKP.isElvUI then
    BohemkaDKP.REQUIRED_ADDONS["ElvUI"] = false
end

EventFrame:SetScript('OnEvent', function(self, event, ...)
    if self[event] then
        self[event](self, ...)
    end
end)

function EventFrame:ADDON_LOADED(name)
    local requiredAddon = BohemkaDKP.REQUIRED_ADDONS[name]
    if requiredAddon ~= nil then
        BohemkaDKP:Debug('Required addon', name, 'loaded')
        BohemkaDKP.REQUIRED_ADDONS[name] = true
    end
    local requiredAddonsLoaded = true
    for _, v in pairs (BohemkaDKP.REQUIRED_ADDONS) do
        if not v then
            requiredAddonsLoaded = false
        end
    end
    if requiredAddonsLoaded then
        initAddon()
    else
        if BohemkaDKP.isElvUI and ElvUI then
            initAddon()
        end
    end
end
function addonLoader(self, name)
    --if name == "Blizzard_TradeSkillUI" then
    --    hooksecurefunc("TradeSkillFrame_OnShow", function(frame)
    --        BohemkaDKP:Print(frame:IsVisible(), GetNumCrafts())
    --
    --    end)
    --elseif name == "Blizzard_CraftUI" then
    --     hooksecurefunc("CraftFrame_OnShow", function(frame)
    --        BohemkaDKP:ShareCraftsInit()
    --    end)
    --end
end
function initAddon()
    -- EventFrame:UnregisterEvent('ADDON_LOADED')
    EventFrame.ADDON_LOADED = addonLoader
    BohemkaDKP:Debug('All required addons loaded. Initializing...')
    local success = C_ChatInfo.RegisterAddonMessagePrefix(AddonName)
    if success then
        loadDefaults()
        BohemkaDKP:OnLoad()
    else
        BohemkaDKP:Print("Failed to register messaging event!")
    end
end
BohemkaDKP.lastOnlineMembers = 0
function EventFrame:GUILD_ROSTER_UPDATE(...)
    if not GuildFrame:IsShown() then
        GuildStatus_UpdateHook()
    end
    local _, onlineMembers, _ = GetNumGuildMembers();
    if BohemkaDKP.lastOnlineMembers < onlineMembers then
        BohemkaDKP:SharePlayerData()
    end
    BohemkaDKP.lastOnlineMembers = onlineMembers

    if not BohemkaDKP:CanWipeData() then
        BohemkaDKPInterfaceOptionsPanelWipe:Disable()
    else
        BohemkaDKPInterfaceOptionsPanelWipe:Enable()
    end
    if not self.firstLoad then
        BohemkaDKP:SaveCharacterInfo()
    end

end
function loadDefaults()
    BohemkaDKPConfig.bench = BohemkaDKPConfig.bench or {}
    BohemkaDKPConfig.collapsed = BohemkaDKPConfig.collapsed or {}
    BohemkaDKPConfig.benchSize = BohemkaDKPConfig.benchSize or 10
    BohemkaDKPConfig.debug = BohemkaDKPConfig.debug or false
    BohemkaDKPConfig.showOfflineMembers = BohemkaDKPConfig.showOfflineMembers or true
    BohemkaDKPConfig.startAuctionModifier = BohemkaDKPConfig.startAuctionModifier or "ALT"
end

function EventFrame:GET_ITEM_INFO_RECEIVED(itemId, success)
    if BohemkaDKP.waitForItemInfo and success and itemId == BohemkaDKP.currentItem.id then
        BohemkaDKP.waitForItemInfo = false
        local itemName, _, itemRarity, _, _, _, _, _, _, itemTexture, _ = GetItemInfo(itemId)
        BohemkaDKP:LoadAuctionData(itemId,  BohemkaDKP.currentItem.quantity,  BohemkaDKP.currentItem.price, itemName, itemRarity, itemTexture)
    end
end

function EventFrame:CHAT_MSG_SKILL()
    if IsInGuild() then
        BohemkaDKP:ShareProfessions()
    end
end
local hookedFrames = {}

function EventFrame:LOOT_OPENED()
    if BohemkaDKP.isElvUI then
        for i=1, GetNumLootItems() do
            local frame = _G["ElvLootSlot"..i]
            if frame and not hookedFrames[frame] then
                hookedFrames[frame] = true
                BohemkaDKP:HookLootItemFrameElvUI(frame, i)
            end
        end
    end

end

BohemkaDKP.events = {
    [BohemkaDKP.EVENT.START_AUCTION] = BohemkaDKP.OnStartAuction,
    [BohemkaDKP.EVENT.BID] = BohemkaDKP.OnBid,
    [BohemkaDKP.EVENT.BID_REQUEST] = BohemkaDKP.OnBidRequest,
    [BohemkaDKP.EVENT.BID_COOLDOWN_END] = BohemkaDKP.OnBidCooldownEnd,
    [BohemkaDKP.EVENT.END_AUCTION] = BohemkaDKP.OnEndAuction,
    [BohemkaDKP.EVENT.END_AUCTION_COUNTDOWN] = BohemkaDKP.OnEndAuctionCountdown,
    [BohemkaDKP.EVENT.END_AUCTION_COUNTDOWN_CANCEL] = BohemkaDKP.OnEndAuctionCountdownCancel,
    [BohemkaDKP.EVENT.PROFESSION_INFO] = BohemkaDKP.OnProfessionInfo,
    [BohemkaDKP.EVENT.TALENTS_INFO] = BohemkaDKP.OnTalentsInfo,
    [BohemkaDKP.EVENT.INVALIDATE_HIGHEST_BID] = BohemkaDKP.OnInvalidateHighestBid,
    [BohemkaDKP.EVENT.AUCTION_JOIN] = BohemkaDKP.OnAuctionJoin,
    [BohemkaDKP.EVENT.AUCTION_JOIN_RESPONSE] = BohemkaDKP.OnAuctionJoinResponse,
    [BohemkaDKP.EVENT.PROFESSION_INFO_REQUEST] = BohemkaDKP.OnProfessionInfoRequest,
    [BohemkaDKP.EVENT.TALENTS_INFO_REQUEST] = BohemkaDKP.OnTalentsInfoRequest,
    [BohemkaDKP.EVENT.PASS_REQUEST] = BohemkaDKP.OnPassRequest,
    [BohemkaDKP.EVENT.LOG] = BohemkaDKP.OnLog,
    [BohemkaDKP.EVENT.SYNC_LOG] = BohemkaDKP.OnSyncLog,
    [BohemkaDKP.EVENT.WIPE_DATA] = BohemkaDKP.OnWipeData,
    [BohemkaDKP.EVENT.WIPE_DATA_ALL] = BohemkaDKP.OnWipeDataAll,
    [BohemkaDKP.EVENT.PAYLOAD_START] = BohemkaDKP.OnPayloadStart,
    [BohemkaDKP.EVENT.PAYLOAD_START_CONFIRM] = BohemkaDKP.OnPayloadStartConfirm,
    [BohemkaDKP.EVENT.ONLINE_CHECK] = BohemkaDKP.OnOnlineCheck,
    [BohemkaDKP.EVENT.ONLINE_CHECK_RESPONSE] = BohemkaDKP.OnOnlineCheckResponse,
    [BohemkaDKP.EVENT.CHARACTERS_INFO] = BohemkaDKP.OnCharactersInfo,
    [BohemkaDKP.EVENT.CHARACTERS_INFO_REQUEST] = BohemkaDKP.OnCharactersInfoRequest,
    [BohemkaDKP.EVENT.WHISPER] = BohemkaDKP.OnWhisper,
    [BohemkaDKP.EVENT.CRAFT] = BohemkaDKP.OnCraft,
    [BohemkaDKP.EVENT.BROADCAST_START] = BohemkaDKP.OnBroadcastStart,
    [BohemkaDKP.EVENT.VERSION_INFO_REQUEST] = BohemkaDKP.OnVersionInfoRequest,
    [BohemkaDKP.EVENT.VERSION_INFO] = BohemkaDKP.OnVersionInfo,
}

function EventFrame:CHAT_MSG_ADDON(prefix, message, channel, sender)
    if prefix == AddonName then
        if message:sub(1, 1) == BohemkaDKP.COMPRESSED_SEPARATOR then
            local _, name = strsplit(BohemkaDKP.EVENT_SEPARATOR, message:sub(2), 3)
            local id, order, msg
            if name == BohemkaDKP:GetPlayerName(true) then
                id, name, order, msg = strsplit(BohemkaDKP.EVENT_SEPARATOR, message:sub(2), 4)
            else
                id, order, msg = strsplit(BohemkaDKP.EVENT_SEPARATOR, message:sub(2), 3)
            end

            id = tonumber(id)
            local chunks = BohemkaDKP.chunks[id]
            if not chunks then
                return
            end
            chunks.received = chunks.received + 1
            order = tonumber(order)
            if not order then
                return
            end
            chunks.data[order] = msg
            BohemkaDKP:Debug("Saved chunk", order, id, chunks.received.."/"..chunks.size)
            if chunks.size == chunks.received then
                BohemkaDKP.chunks[id] = nil
                BohemkaDKP:Debug("Processing chunks", id)
                if not chunks.data then
                    return
                end
                local payload = table.concat(table.removeNil(chunks.data))

                BohemkaDKP:Debug("Decoding chunks", id)
                local decoded = LibDeflate:DecodeForWoWAddonChannel(payload)
                if not decoded then
                    BohemkaDKP:Debug("Decoding failed", id)
                    return
                end
                BohemkaDKP:Debug("Decompressing chunks", id)
                local decompressed = LibDeflate:DecompressDeflate(decoded)
                if not decompressed then
                    BohemkaDKP:Debug("Decompression failed", id)
                    return
                end
                BohemkaDKP:Debug("Deserializing chunks", id)
                local success, data = LibSerialize:Deserialize(decompressed)
                if not success then
                    BohemkaDKP:Debug("Deserializing failed", id)
                    return
                end
                data = BohemkaDKP:split(data, "\n")
                for _, itemStr in ipairs(data) do
                    BohemkaDKP:ProcessEvent(itemStr, channel, sender)
                end
                BohemkaDKP.chunks[id] = nil
                if BohemkaDKP.syncDone[sender] ~= nil then
                    BohemkaDKP.syncDone[sender] = true
                end
                if BohemkaDKP:IsSyncFinished() then
                    self.initialSync = true
                end
            end
            return
        end
        if not string.find(sender, "-") then
            sender = sender.."-"..GetRealmName()
        end
        BohemkaDKP:ProcessEvent(message, channel, sender)
    end
end

function BohemkaDKP:ProcessEvent(message, channel, sender)
    local data = { strsplit(BohemkaDKP.EVENT_SEPARATOR, message) }
    table.insert(data, sender)
    table.insert(data, channel)
    local event = table.remove(data,1)
    if BohemkaDKP.events[event] then
        BohemkaDKP:Debug("Received event", event, "| args:", unpack(data))
        BohemkaDKP.events[event](BohemkaDKP, unpack(data))
    end
end

function EventFrame:PLAYER_ENTERING_WORLD(isLogin, isReload)
    if not isLogin and not isReload then
        return
    end
    GuildRoster()
    BohemkaDKP.firstLoad = true
    if IsInGuild() then
        BohemkaDKP:LoadDataWhenReady()
        BohemkaDKP:JoinExistingAuction()
    end
end

function EventFrame:COMBAT_LOG_EVENT_UNFILTERED()
    local _, eventType, _, _, _, _, _, _, destName, _, _, recapID, _ = CombatLogGetCurrentEventInfo()
    if eventType == "UNIT_DIED" or eventType == "UNIT_DESTROYED" or eventType == "UNIT_DISSIPATES" then
        if not IsInRaid() or not UnitIsGroupLeader("player") then
            return
        end
        recapLink = GetDeathRecapLink(recapID)
        if BohemkaDKPConfig.bossRewards[destName] then
            BohemkaDKP:AwardDKPRaid(BohemkaDKPConfig.bossRewards[destName], "killing of "..destName)
        end
    end
end


function EventFrame:GROUP_ROSTER_UPDATE()
    if not IsInRaid() then
        ButtonAwardRaidDKP:Hide()
    else
        ButtonAwardRaidDKP:Show()
    end
end


function EventFrame:PLAYER_LOGOUT()
    if BohemkaDKP:IsSyncFinished() and IsInGuild() then
        BohemkaDKPConfig.lastTimeOnline = GetServerTime()
    end
end


function EventFrame:CHAT_MSG_GUILD(...)
    BohemkaDKP:ChatBid(...)
end

function EventFrame:CHAT_MSG_RAID(...)
    BohemkaDKP:ChatBid(...)
end

function EventFrame:CHAT_MSG_RAID_LEADER(...)
    BohemkaDKP:ChatBid(...)
end

function EventFrame:CHAT_MSG_PARTY(...)
    if IsInRaid() then
        return
    end
    BohemkaDKP:ChatBid(...)
end

function EventFrame:CHAT_MSG_PARTY_LEADER(...)
    if IsInRaid() then
        return
    end
    BohemkaDKP:ChatBid(...)
end

function EventFrame:CRAFT_UPDATE(...)
    BohemkaDKP:ShareCraftsDelayed()
end

function EventFrame:TRADE_SKILL_UPDATE(...)
    BohemkaDKP:ShareTradeSkillsDelayed()
end

