---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 01.07.2021 15:55
---
local AddonName, BohemkaDKP = ...
BohemkaDKP.frames = {}
BIDDER_TABLE_SIZE = 7
PROFESSION_AMOUNT = 6
DKP_LOG_ROW_AMOUNT = 24
DKP_LOG_ROW_HEIGHT = 15
DKP_LOG_FRAME_WIDTH = 557
DKP_LOG_FRAME_HEIGHT = 410
DKP_LOG_REASON_WIDTH = 160


GUILD_FRAME_COLUMN_WIDTH_DKP = 60
GUILD_FRAME_COLUMN_WIDTH_PROFESSIONS = 101
GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_NOTE = 74.5
GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE = 49
GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE_NO_SCROLL = 40
LAST_COLUMN_WIDTH = 87.5
FRIENDS_FRAME_WIDTH = FriendsFrame:GetWidth() + GUILD_FRAME_COLUMN_WIDTH_DKP + GUILD_FRAME_COLUMN_WIDTH_PROFESSIONS

FRIENDS_FRAME_TAB_COUNT = 5
LAST_COLUMN_HEADER_INDEX = 4
LAST_COLUMN_STATUS_HEADER_INDEX = 2
LAST_COLUMN_HEADER_NAME = "Class"
SHOW_OFFLINE_MEMBERS = "Offline Members"

CRAFTS_DISPLAYED = 8
CRAFTS_LIST_DISPLAYED = 19
CRAFTS_LIST_ROW_HEIGHT = 16.5
CRAFT_SKILL_BUTTON_WIDTH = 293

BohemkaDKP.editModeButtons = {
    "SelectAllDKP",
    "ButtonSubtractAll",
    "ButtonAddAll"
}

function BohemkaDKP:AdjustUI()
    self:CreateGuildFrameProfessionsColumnHeader()

    self:CreateGuildFrameGuildStatusNoteColumnHeader()
    self:ReplaceGuildFrameGuildStatusNoteHeaderWithDKP()
    self:CreateGuildFrameEditModeButtons()
    self:CreateGuildCraftFrame()
    self:CreateGuildCraftListFrame()
    GuildFrameLFGButtonText:SetText(SHOW_OFFLINE_MEMBERS)

    for i=1, GUILDMEMBERS_TO_DISPLAY do
        local _, _, _, _, _, _, _, officerNote, _, _ = GetGuildRosterInfo(i)
        self:CreateGuildFrameGuildStatusNote(i, officerNote)
        local profContainer = CreateFrame("Frame", "GuildFrameProfContainer"..i, GuildFrame)
        self:CreateGuildFrameProfessionButton("GuildFrameProf"..i, 15, profContainer, "LEFT", _G["GuildFrameButton"..i..LAST_COLUMN_HEADER_NAME], "RIGHT", -7, 0)
        if not BohemkaDKPConfig.showProfessions then
            profContainer:Hide()
        end
        self:CreateGuildFrameTalentsButton(i)

        self:CreateDKPCheckButton(i)
        self:FixGuildStatusOnlineButton(i)
        self:ReplaceGuildFrameGuildStatusNoteWithDKP(i, GUILD_FRAME_COLUMN_WIDTH_DKP - 20)
        if not BohemkaDKPConfig.showDKP then
            _G["GuildFrameGuildStatusButton"..i.."Note"]:Hide()
        end
        self:FixGuildFrameClassButton(i)


        local charFrame = _G["GuildFrameButton"..i]
        charFrame:SetScript("OnEnter", function(self)
            if self.tooltip then
                GameTooltip:SetOwner(self, "ANCHOR_RIGHT", 0, -27);
                GameTooltip:SetText(self.tooltip);
                GameTooltip:Show();
            end
        end)
        charFrame:SetScript("OnLeave", function()
            GameTooltip:Hide();
        end)

    end
    WhoFrameColumn_SetWidth(_G["GuildFrameColumnHeader"..LAST_COLUMN_HEADER_INDEX], LAST_COLUMN_WIDTH)

    GuildFrameLFGFrame:SetWidth(270)
    GuildFrameLFGFrameMiddle:SetWidth(246)
    GuildFrameLFGFrame:ClearAllPoints(true)
    GuildFrameLFGFrame:SetPoint("TOPLEFT", 60, -25)
    GuildFrameLFGButton:ClearAllPoints(true)
    GuildFrameLFGButton:SetPoint("TOPLEFT", "GuildFrameLFGFrame", 102, -2)
    GuildFrameLFGButtonText:SetPoint("RIGHT", "GuildFrameLFGButton", "LEFT", -3, 1)
    GuildListScrollFrame:HookScript("OnVerticalScroll", function()
        GameTooltip:Hide()
    end)

    local profButton = CreateFrame("CheckButton", "GuildFrameProfButton", GuildFrameLFGFrame, "UICheckButtonTemplate")
    profButton:SetPoint("LEFT", "GuildFrameLFGButton", "RIGHT", 70, 0)
    profButton:SetSize(20, 20)
    profButton:SetChecked(BohemkaDKPConfig.showProfessions)
    profButton:SetScript("OnClick", function(self)
        BohemkaDKPConfig.showProfessions = self:GetChecked()
        BohemkaDKP:RenderColumns()
    end)

    local font = profButton:CreateFontString("$parentText","ARTWORK", "GameFontHighlightSmall")
    font:SetText("Professions")
    font:SetPoint("RIGHT", profButton, "LEFT", -3, 1)


    local dkpButton = CreateFrame("CheckButton", "GuildFrameDKPToggle", GuildFrameLFGFrame, "UICheckButtonTemplate")
    dkpButton:SetPoint("LEFT", "GuildFrameProfButton", "RIGHT", 30, 0)
    dkpButton:SetSize(20, 20)
    dkpButton:SetChecked(BohemkaDKPConfig.showDKP)
    dkpButton:SetScript("OnClick", function(self)
        BohemkaDKPConfig.showDKP =  self:GetChecked()
        BohemkaDKP:RenderColumns()
    end)

    font = dkpButton:CreateFontString("$parentText","ARTWORK", "GameFontHighlightSmall")
    font:SetText("DKP")
    font:SetPoint("RIGHT", dkpButton, "LEFT", -3, 1)
    RaidFrame_LoadUI()
    self:CreateGuildFrameDKPButton()
    self:AdjustDetailFrame()
    self:AdjustRaidFrame()
    self:RenderColumns()
    self:OnUiAdjustedCompatibilityCallback()
    local e = CreateFrame("EditBox", "$parentFakeMOTD", GuildFrameNotesText:GetParent())
    local fontObject = GuildFrameNotesText:GetFontObject();
    e:Hide()
    e:SetFontObject(fontObject)
    e:SetPoint("TOPLEFT", GuildFrameNotesText, 0, 0)
    e:SetSize(GuildFrameNotesText:GetSize())
    e:SetMultiLine(true)
    e:SetAutoFocus(false)
    e:SetNumeric(true)
    --e:SetText("WTF")
    e:SetJustifyH("LEFT")
    e:SetScript( "OnEscapePressed", function( )
        e:ClearFocus()
    end )
    e:SetScript("OnEnterPressed", function(self)
        self:ClearFocus()
    end)
end
function BohemkaDKP:UpdateCompatibility()
    if self.isElvUI then
        LAST_COLUMN_HEADER_INDEX = 2
        LAST_COLUMN_STATUS_HEADER_INDEX = 4
        LAST_COLUMN_HEADER_NAME = "Zone"
        LAST_COLUMN_WIDTH = LAST_COLUMN_WIDTH + 45
        GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE = 80
        GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE_NO_SCROLL = 78
        CRAFTS_LIST_DISPLAYED = 21
        self.OnUpdateCompatibilityCallback = function()
            WhoFrameColumn_SetWidth(GuildFrameColumnHeader1, 92)
            WhoFrameColumn_SetWidth(GuildFrameColumnHeader2, GuildFrameColumnHeader2:GetWidth() + 30)
            WhoFrameColumn_SetWidth(GuildFrameGuildStatusColumnHeader4, GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE_NO_SCROLL)
            for i=1, GUILDMEMBERS_TO_DISPLAY, 1 do
                local btn = getglobal("GuildFrameButton"..i..LAST_COLUMN_HEADER_NAME)
                btn:SetWidth(LAST_COLUMN_WIDTH)
            end
            GuildFrameLFGButton:ClearAllPoints(true)
            GuildFrameLFGButton:SetPoint("TOPLEFT", "GuildFrameLFGFrame", 100, -2)
            GuildFrameLFGFrame:ClearAllPoints(true)
            GuildFrameLFGFrame:SetPoint("TOPLEFT", 1, -25)
        end
        self.OnUiAdjustedCompatibilityCallback = function()
            if not ElvUI[1].initialized then
                local fn = ElvUI[1].Initialize
                ElvUI[1].Initialize = function(...)
                    fn(...)
                    BohemkaDKP:OnUiAdjustedCompatibilityCallback()
                end
                return
            end
            LootMasterFrame:SetPoint("TOPLEFT", BohemkaDKPAuctionFrame, "TOPRIGHT", 0, 0)
            BohemkaDKPAuctionFrameHeader:SetPoint("TOP", 0, 6)
            BidValue:SetPoint("BOTTOM", 0, 7)
            BidValue:SetTextInsets(5,5,0,0)
            BohemkaDKPAuctionFrameArrow:SetTexture("Interface\\Glues\\Common\\Glue-RightArrow-Button-Up")
            BohemkaDKPAuctionFrame.currentDKPValue:SetSize(20, 14)
            BohemkaDKPAuctionFrame.totalDKPValue:SetSize(20, 14)
            BohemkaDKPAuctionFrame.currentDKPValue:SetJustifyH("RIGHT")
            BohemkaDKPAuctionFrame.totalDKPValue:SetJustifyH("LEFT")

            BohemkaDKPLogFrame:SetPoint("TOPLEFT", GuildMemberDetailFrame, "TOPRIGHT", 4, 1)
            GuildCraftListFrame:SetPoint("TOPLEFT", GuildFrame, "TOPRIGHT", 0, 0)
            GuildCraftListFrame:SetSize(354, 424)
            GuildCraftFrame:SetSize(354, 424)
            GuildCraftFrame.attachedX = 2
            GuildCraftFrame.detachedY = 0
            GuildCraftListFrameClear:ClearAllPoints(true)
            GuildCraftFrameClear:ClearAllPoints(true)
            GuildCraftListFrameClear:SetPoint("BOTTOMLEFT", 183 , 3)
            GuildCraftFrameClear:SetPoint("BOTTOMLEFT", 183 , 3)
            GuildCraftMemberSearchValue:ClearAllPoints(true)
            GuildCraftListMemberSearchValue:ClearAllPoints(true)
            GuildCraftMemberSearchValue:SetPoint("BOTTOMLEFT", GuildCraftFrame, 15, 5)
            GuildCraftMemberSearchValue:SetHeight(18)
            GuildCraftListMemberSearchValue:SetHeight(18)
            GuildCraftMemberSearchValue:SetTextInsets(5,5,0,0)
            GuildCraftListMemberSearchValue:SetTextInsets(5,5,0,0)
            GuildCraftListMemberSearchValue:SetPoint("BOTTOMLEFT", GuildCraftListFrame, 15, 5)

            GuildCraftListFrameClose:SetPoint("TOPRIGHT", 0 , 0)
            GuildCraftFrameClose:SetPoint("TOPRIGHT", 0 , 0)
            GuildCraftListFrameTitle:SetPoint("TOP", 0 , -5)
            GuildCraftFrameTitle:SetPoint("TOP", 0 , -5)
            GuildCraftListFrameScrollFrame:SetPoint('TOPRIGHT', -30, -45)
            GuildCraftListFrameScrollFrameTop:Hide()
            GuildCraftListFrameScrollFrameBottom:Hide()
            GuildCraftListFrameScrollFrameMiddle:Hide()
            --GuildCraftFrameScrollFrameTop:Hide()
            --GuildCraftFrameScrollFrameBottom:Hide()
            --GuildCraftFrameScrollFrameMiddle:Hide()
            GuildCraftFrameScrollFrame:ClearAllPoints(true)
            GuildCraftFrameScrollFrame:SetPoint('TOPRIGHT', -40, -65)
            _G["GuildCraftListFrameSkillFrame1"]:SetPoint("TOPLEFT", 22, -45)
            _G["GuildCraftFrameSkillFrame1"]:SetPoint("TOPLEFT", 17, -65)
            GuildCraftFrameSkillRankFrame:SetPoint("TOPLEFT", 8, -37)
            GuildCraftFrameSkillRankFrame:SetSize(336, 17)
            GuildCraftFramePlayerReagents:SetPoint("TOPLEFT", 80, -15)
            GuildCraftListFrameOfflineMembers:SetPoint("TOPLEFT", 110, -20)
            GuildCraftFrameScrollDetailFrame:SetPoint('TOPLEFT', 17, -214)

            ElvUI[1].Skins:HandleIcon(GuildCraftFrameScrollDetailFrameChildFrameSkillIconTexture, true)
            for i = 1, 8 do
                local icon = _G['GuildCraftFrameScrollDetailFrameChildFrameSkillReagent'..i..'IconTexture']
                local count = _G['GuildCraftFrameScrollDetailFrameChildFrameSkillReagent'..i..'Count']
                local nameFrame = _G['GuildCraftFrameScrollDetailFrameChildFrameSkillReagent'..i..'NameFrame']

                ElvUI[1].Skins:HandleIcon(icon, true)
                icon:SetDrawLayer('OVERLAY')
                count:SetDrawLayer('OVERLAY')

                nameFrame:SetAlpha(0)
            end

            local arrowText = BohemkaDKPAuctionFrame:CreateFontString("$parentArrowText", "OVERLAY", "GameFontNormalSmall")
            arrowText:SetPoint("BOTTOM", 0, 50)
            arrowText:SetText("->")

            for _, v in ipairs({
                LootMasterFrame, BohemkaDKPAuctionFrame, LootMasterFrameBG, BohemkaDKPAuctionFrameStatusBarContainer,
                BohemkaDKPLogFrame, BohemkaDKPInterfaceOptionsPanelEditBoxItemPrice,
                BohemkaDKPInterfaceOptionsPanelEditBoxBossRewards, GuildCraftListFrame, GuildCraftFrame
            }) do
                v:StripTextures()
                ElvUI[1].Skins:HandleFrame(v, true)
            end
            local statusBars = {
                GuildCraftFrameSkillRankFrame,
            }
            for i=1, CRAFTS_LIST_DISPLAYED do
                local statusBar = _G["GuildCraftListFrameSkillFrame"..i.."SkillButtonRankFrame"]
                table.insert(statusBars, statusBar)
            end
            for _, v in ipairs(statusBars) do
                ElvUI[1].Skins:HandleStatusBar(v, {0.03, 0.25, 0.70})
            end
            for _, v in ipairs({
                BohemkaDKPAuctionFrameStatusBarContainerStatusBar,
            }) do
                v:StripTextures()
                ElvUI[1].Skins:HandleStatusBar(v)
            end

            AuctionDKPClose:SetPoint("TOPRIGHT", BohemkaDKPAuctionFrame, "TOPRIGHT", 0, 0)
            for _, v in ipairs({
                AuctionDKPClose, BohemkaDKPLogFrameClose, GuildCraftListFrameClose, GuildCraftFrameClose
            }) do
                v:StripTextures()
                ElvUI[1].Skins:HandleCloseButton(v)
            end

            for _, v in ipairs({
                BohemkaDKPInterfaceOptionsPanelAuctionKeyBind
            }) do
                v:StripTextures()
                ElvUI[1].Skins:HandleDropDownBox(v)
            end

            for _, v in ipairs({
                BohemkaDKPLogFrameScrollFrameScrollBar,
                BohemkaDKPInterfaceOptionsPanelEditBoxItemPriceScrollScrollBar,
                BohemkaDKPInterfaceOptionsPanelEditBoxBossRewardsScrollScrollBar,
                GuildCraftListFrameScrollFrameScrollBar,
                GuildCraftFrameScrollFrameScrollBar,
                GuildCraftFrameScrollDetailFrameScrollBar
            }) do
                v:StripTextures()
                ElvUI[1].Skins:HandleScrollBar(v)
            end

            for _, v in ipairs({
                ButtonAdd, ButtonSubtract, ButtonAddAll,
                ButtonSubtractAll, ButtonAwardRaidDKP, SelectAllDKP,
                GuildFrameDKPButton, BohemkaDKPInterfaceOptionsPanelImport, BohemkaDKPImportFrameImport,
                BohemkaDKPInterfaceOptionsPanelExport,
                BohemkaDKPInterfaceOptionsPanelBackup,
                BohemkaDKPInterfaceOptionsPanelWipe,
                BidButton, ButtonPass, ButtonLMCancel, ButtonLMAward, AuctionFrameItem,
                ButtonLog, GuildCraftListFrameClear, GuildCraftFrameClear, GuildCraftListFrameCloseButton, GuildCraftFrameCloseButton
            }) do
                v:StripTextures()
                v:StyleButton()
                ElvUI[1].Skins:HandleButton(v)
            end
            AuctionFrameItemIconTexture:SetTexCoord(0.1, 0.90, 0.05, 0.95)

            for _, v in ipairs({
                GuildFrameGuildStatusColumnHeader5,
                GuildFrameColumnHeader6,
                BidderNameHeader1,
                BidderNameHeader2,
                BidderNameHeader3,
            }) do
                v:StripTextures()
                v:StyleButton()
            end

            for _, v in ipairs({
                BidValue,
                BohemkaDKPInterfaceOptionsPanelEditBoxMinimalBid,
                BohemkaDKPInterfaceOptionsPanelEditBoxAuctionCountdown,
                BohemkaDKPInterfaceOptionsPanelEditBoxAutoBackup,
                BohemkaDKPInterfaceOptionsPanelEditBoxBidCooldown,
                BohemkaDKPInterfaceOptionsPanelEditBoxMinItemPrice,
                BohemkaDKPInterfaceOptionsPanelEditBoxStartingDKP,
                GuildCraftMemberSearchValue,
                GuildCraftListMemberSearchValue
            }) do
                v:StripTextures()
                ElvUI[1].Skins:HandleEditBox(v)
            end
            for _, v in ipairs({
                GuildCraftFrameScrollDetailFrame,
                GuildCraftFrameScrollDetailFrameChildFrame,
                GuildCraftFrameScrollFrame,
            }) do
                v:StripTextures()
            end

            local checkButtons = {
                GuildFrameProfButton, GuildFrameDKPToggle, BohemkaDKPInterfaceOptionsPanelDebug, GuildCraftFramePlayerReagents, GuildCraftListFrameOfflineMembers
            }
            for i=1, GUILDMEMBERS_TO_DISPLAY, 1 do
                local button = _G["GuildFrameButton"..i]
                local iconFrame = _G["GuildFrameSpecContainer"..i]
                local icon = _G["GuildFrameSpecContainer"..i.."SpecIcon"]
                iconFrame:ClearAllPoints()
                iconFrame:SetPoint("LEFT", button, 63, 0)
                iconFrame:CreateBackdrop('Default', true)
                iconFrame.backdrop:SetAllPoints(icon)
                table.insert(checkButtons, _G["GuildFrameDKPSelectButton"..i])
            end
            for _, btn in ipairs(checkButtons) do
                btn:StripTextures()
                btn:StyleButton()
                ElvUI[1].Skins:HandleCheckBox(btn)
            end
        end
    end
end
function BohemkaDKP:ReplaceGuildFrameGuildStatusNoteHeaderWithDKP()
    local noteBtn = _G["GuildFrameGuildStatusColumnHeader3"]
    noteBtn:SetParent(GuildFrame)
    noteBtn:SetText("DKP")
    noteBtn:SetPoint("LEFT", "GuildFrameColumnHeader6", "RIGHT", -2, 0)
    WhoFrameColumn_SetWidth(noteBtn, GUILD_FRAME_COLUMN_WIDTH_DKP)
end
function BohemkaDKP:CreateGuildFrameGuildStatusNote(index, value)
    local font = _G["GuildFrameGuildStatusButton"..index]:CreateFontString("GuildFrameGuildStatusButton"..index.."OfficerNote","ARTWORK", "GameFontHighlightSmall")
    font:SetJustifyH("LEFT")
    font:SetText(value)
    font:SetSize(GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_NOTE, 14)
    font:SetPoint("LEFT", "GuildFrameGuildStatusButton"..index.."Rank", "RIGHT", 11, 0)
end
function BohemkaDKP:AdjustGuildFrameButtonWidth(index, width)
    for _, button in ipairs({_G["GuildFrameGuildStatusButton"..index], _G["GuildFrameButton"..index]}) do
        button:SetWidth(width)
        local highlightTexture = button:GetHighlightTexture()
        highlightTexture:SetWidth(width)
    end
end
function BohemkaDKP:ReplaceGuildFrameGuildStatusNoteWithDKP(index, width)
    local noteButton = _G["GuildFrameGuildStatusButton"..index.."Note"]
    noteButton:SetParent(GuildFrame)
    noteButton:SetJustifyH("RIGHT")
    noteButton:SetWidth(width)
    noteButton:SetPoint("LEFT", "GuildFrameProf"..index.."Frame"..PROFESSION_AMOUNT, "RIGHT", -2, 0)
end
function BohemkaDKP:CreateDKPCheckButton(index)
    local dkpCheckButton = CreateFrame("CheckButton", "GuildFrameDKPSelectButton"..index, GuildFrame, "UICheckButtonTemplate");
    dkpCheckButton:SetPoint("LEFT", "GuildFrameGuildStatusButton"..index.."Note", "RIGHT", 2, 0)
    dkpCheckButton:SetFrameStrata("HIGH")
    dkpCheckButton:Hide()
    dkpCheckButton:SetSize(18,18)
    dkpCheckButton:SetScript("OnClick", function(self)
        local guildOffset = FauxScrollFrame_GetOffset(GuildListScrollFrame)
        local guildIndex = guildOffset + index
        local isChecked = self:GetChecked()
        local fullName = GetGuildRosterInfo(guildIndex)
        BohemkaDKP.editModeSelected[fullName] = isChecked
    end)
end
function BohemkaDKP:FixGuildStatusOnlineButton(index)
    local onlineButton = _G["GuildFrameGuildStatusButton"..index.."Online"]
    onlineButton:SetWidth(GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE)
    onlineButton:SetPoint("LEFT", "GuildFrameGuildStatusButton"..index.."OfficerNote", "RIGHT", 10, 0)
end
function BohemkaDKP:FixGuildFrameClassButton(index)
    local classButton = _G["GuildFrameButton"..index..LAST_COLUMN_HEADER_NAME]
    classButton:SetWidth(LAST_COLUMN_WIDTH)
end
function BohemkaDKP:AdjustRaidFrame()
    local awardRaid = CreateFrame("Button", "ButtonAwardRaidDKP", RaidFrame, "UIPanelButtonTemplate")
    awardRaid:SetPoint("TOPRIGHT", RaidFrame, "TOPRIGHT", -25, -1)
    awardRaid:SetSize(90, 19)
    awardRaid:SetText("Award DKP")
    awardRaid:SetNormalFontObject("GameFontNormalSmall")
    awardRaid:SetHighlightFontObject("GameFontHighlightSmall")
    awardRaid:SetDisabledFontObject("GameFontDisableSmall")
    awardRaid:RegisterForClicks("AnyUp")
    awardRaid:SetScript("OnClick", function()
        StaticPopup_Show("AWARD_GUILDPLAYERDKP_RAID")
    end)

    if not IsInRaid() then
        awardRaid:Hide()
    end
end
function BohemkaDKP:AdjustDetailFrame()
    local detailNoteLabel = _G["GuildMemberDetailNoteLabel"]
    local detailFrame = _G["GuildMemberDetailFrame"]
    detailNoteLabel:SetText("DKP:")

    f = CreateFrame("Frame", "DetailFrameDKPFrame", detailFrame);
    f:SetPoint("LEFT", "GuildFrameGuildStatusColumnHeader2", "RIGHT", -2, 0)
    f:SetSize(60, 14)
    f:SetPoint("LEFT", detailNoteLabel, "RIGHT", 2, 0)
    f:SetScript("OnMouseUp", function()
        if CanEditPublicNote() then
            StaticPopup_Show("SET_GUILDPLAYERDKP")
        end
    end)
    font = f:CreateFontString("GuildMemberDetailFrameDKP","ARTWORK", "GameFontHighlightLeft")
    font:SetWidth(60)
    font:SetPoint("LEFT")

    detailNoteLabel.dkp = font
    _G["GuildMemberDetailOfficerNoteLabel"]:SetText(NOTE_COLON)
    _G["GuildMemberDetailOfficerNoteLabel"]:SetPoint("TOPLEFT", detailNoteLabel, "BOTTOMLEFT", 0, -8)
    _G["GuildMemberNoteBackground"]:Hide()

    self:CreateGuildFrameProfessionButton("DetailFrameProf", 30, _G["GuildMemberOfficerNoteBackground"], "TOPLEFT", "GuildMemberOfficerNoteBackground", "BOTTOMLEFT", -1, -5)

    local subtract = CreateFrame("Button", "ButtonSubtract", f, "UIPanelButtonTemplate")
    subtract:SetPoint("LEFT", f, "RIGHT", 5, 0)
    subtract:SetSize(30, 20)
    subtract:SetText("-")
    subtract:RegisterForClicks("AnyUp")
    subtract:SetScript("OnClick", function()
        StaticPopup_Show("SUBTRACT_GUILDPLAYERDKP")
    end)
    subtract:Hide()
    local add = CreateFrame("Button", "ButtonAdd", f, "UIPanelButtonTemplate")
    add:SetPoint("LEFT", subtract, "RIGHT", 0, 0)
    add:SetSize(30, 20)
    add:SetText("+")
    add:RegisterForClicks("AnyUp")
    add:SetScript("OnClick", function()
        StaticPopup_Show("ADD_GUILDPLAYERDKP")
    end)
    add:Hide()
    local log = CreateFrame("Button", "ButtonLog", f, "UIPanelButtonTemplate")
    log:SetPoint("LEFT", add, "RIGHT", 0, 0)
    log:SetSize(30, 20)
    log:SetText("?")
    log:RegisterForClicks("AnyUp")
    log:SetScript("OnClick", function()
        if BohemkaDKPLogFrame:IsShown() then
            BohemkaDKPLogFrame:Hide()
        else
            BohemkaDKPLogFrame:Show()
        end
    end)

    ButtonLogText:SetPoint("BOTTOM", 0, 4)
    ButtonAddText:SetPoint("BOTTOM", 0, 4)
    ButtonSubtractText:SetPoint("BOTTOM", 0, 4)

    f.subtract = subtract
    f.add = add



    local logFrame = CreateFrame("Frame", "BohemkaDKPLogFrame", detailFrame,  BackdropTemplateMixin and "BackdropTemplate" or nil)
    logFrame:SetPoint("TOPLEFT", detailFrame, "TOPRIGHT")
    logFrame:SetSize(DKP_LOG_FRAME_WIDTH, DKP_LOG_FRAME_HEIGHT)
    logFrame:SetBackdrop(BACKDROP_DIALOG_32_32)

    local f2 = CreateFrame("BUTTON", "$parentClose", logFrame, "UIPanelCloseButton");
    f2:SetPoint("TOPRIGHT", logFrame, "TOPRIGHT", -4, -4)

    --
    --local bg = logFrame:CreateTexture(nil, "ARTWORK")
    --bg:SetPoint("TOPLEFT", 11, -11)
    --bg:SetPoint("BOTTOMRIGHT", -11, 11)
    --bg:SetTexture("Interface\\FrameGeneral\\UI-Background-Rock")




    --local marble = logFrame:CreateTexture(nil, "ARTWORK")
    --marble:SetPoint("TOPLEFT", 12, -39)
    --marble:SetPoint("BOTTOMRIGHT", -12, 12)
    --marble:SetTexture("Interface\\FrameGeneral\\UI-Background-Marble")

    local dateCol = self:CreateDKPLogHeader("Date", 125, "Date/Time", "CENTER", "TOPLEFT", logFrame, "TOPLEFT", 9, -11)
    local net = self:CreateDKPLogHeader("Net", 60, "Net", "CENTER", "LEFT", dateCol, "RIGHT")
    local delta = self:CreateDKPLogHeader("Delta", 70, "Delta", "CENTER", "LEFT", net, "RIGHT", -10, 0)
    local desc = self:CreateDKPLogHeader("Reason", DKP_LOG_REASON_WIDTH, "Reason", "LEFT", "LEFT", delta, "RIGHT")
    local editor = self:CreateDKPLogHeader("Owner", 100, "Actionee", "CENTER", "LEFT", desc, "RIGHT")

    local logFrameBody = CreateFrame("Frame", "BohemkaDKPLogFrameScrollFrameScrollChildFrame", logFrame,  BackdropTemplateMixin and "BackdropTemplate" or nil)
    logFrameBody:SetPoint("TOPLEFT", dateCol, "BOTTOMLEFT", 0, 0)
    logFrameBody:SetSize(logFrame:GetWidth(), logFrame:GetHeight() - dateCol:GetHeight())

    local Scroll = CreateFrame('ScrollFrame', '$parentScrollFrame', logFrame, 'UIPanelScrollFrameTemplate')
    Scroll:SetPoint('TOPLEFT', logFrame, 'TOPLEFT', 10, -37)
    Scroll:SetPoint('BOTTOMRIGHT', logFrame, 'BOTTOMRIGHT', -34, 10)
    Scroll:SetScript("OnVerticalScroll", function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, DKP_LOG_ROW_HEIGHT, function()
            GameTooltip:Hide()
            BohemkaDKP:UpdateDKPLog()
        end)
    end)

    local prevRow = dateCol
    for i=1, DKP_LOG_ROW_AMOUNT do
        local row = CreateFrame("Frame", "BohemkaDKPLogFrameRow"..i, logFrameBody,  BackdropTemplateMixin and "BackdropTemplate" or nil)
        row:SetPoint("TOPLEFT", prevRow, "BOTTOMLEFT")
        row:SetSize(DKP_LOG_FRAME_WIDTH - 20, DKP_LOG_ROW_HEIGHT)

        local dateFont = row:CreateFontString("$parentDate","ARTWORK", "GameFontHighlightSmall")
        dateFont:SetPoint("LEFT", 0, 0)
        dateFont:SetSize(dateCol:GetWidth(), DKP_LOG_ROW_HEIGHT)

        local netFont = row:CreateFontString("$parentNet","ARTWORK", "GameFontHighlightSmall")
        netFont:SetPoint("LEFT", dateFont, "RIGHT", 2, 0)
        netFont:SetSize(net:GetWidth() - 20, DKP_LOG_ROW_HEIGHT)
        netFont:SetJustifyH("RIGHT")

        local deltaFont = row:CreateFontString("$parentDelta","ARTWORK", "GameFontHighlightSmall")
        deltaFont:SetPoint("LEFT", netFont, "RIGHT", 15, 0)
        deltaFont:SetSize(delta:GetWidth() - 30, DKP_LOG_ROW_HEIGHT)
        deltaFont:SetJustifyH("RIGHT")

        local descFrame = CreateFrame("Button", "$parentDescFrame", row)
        descFrame:SetScript("OnEnter", function(self)
            if self.tooltip or self.itemLink then
                GameTooltip:SetOwner(self, "ANCHOR_RIGHT", 0, -24);
                if self.itemLink then
                    GameTooltip:SetHyperlink(self.itemLink);
                elseif self.tooltip then
                    GameTooltip:SetText(self.tooltip);
                end

                GameTooltip:Show();
            end
        end)
        descFrame:SetScript("OnLeave", function()
            GameTooltip:Hide();
        end)
        descFrame:Hide()

        local descFont = descFrame:CreateFontString("$parentDesc","ARTWORK", "GameFontHighlightSmall")
        descFont:SetPoint("LEFT", deltaFont, "RIGHT", 25, 0)
        descFont:SetSize(desc:GetWidth() - 5, DKP_LOG_ROW_HEIGHT)
        descFont:SetJustifyH("LEFT")
        descFrame:SetAllPoints(descFont);

        local descFrameMenu = CreateFrame("Frame", "$parentMenu", descFrame, "UIDropDownMenuTemplate")
        descFrame:RegisterForClicks("AnyUp")
        descFrame:SetScript("OnClick", function(self)
            if self.enableDropdown then
                ToggleDropDownMenu(1, nil, descFrameMenu, "cursor", 3, -3)
            end
        end)
        descFrame.menu = descFrameMenu

        -- UIDropDownMenu_SetWidth(descFrame, 50)
        UIDropDownMenu_Initialize(descFrameMenu, function(_, level, _)
            local info = UIDropDownMenu_CreateInfo()
            info.keepShownOnClick = false
            info.notCheckable = true
            if level == 1 then
                info.text = "Add reason"
                info.func = function()
                    local dialog = StaticPopup_Show("ADD_REASON_LOG", descFrame)
                    dialog.data = descFrame
                end
                UIDropDownMenu_AddButton(info, level)
                info.text = "Revert"
                info.func = function()
                    local currentDKP = BohemkaDKP:GetCurrentDKP(descFrame.fullName)
                    BohemkaDKP:AddReason(descFrame, "Reverted - "..date('%Y/%m/%d %H:%M', GetServerTime()), 1)
                    BohemkaDKP:SaveDKP(BohemkaDKP.rosterIndex[descFrame.fullName], currentDKP + (descFrame.item.prev - descFrame.item.current), "GUILD", "Reverted external edit")
                end
                UIDropDownMenu_AddButton(info, level)
            end
        end, "MENU")

        local editorFont = row:CreateFontString("$parentOwner","ARTWORK", "GameFontHighlightSmall")
        editorFont:SetPoint("LEFT", descFont, "RIGHT", 3, 0)
        editorFont:SetSize(editor:GetWidth(), DKP_LOG_ROW_HEIGHT)
        editorFont:SetJustifyH("CENTER")
        prevRow = row
    end


end
function BohemkaDKP:CreateDKPLogHeader(name, width, text, justify, ...)
    local date = CreateFrame("BUTTON", "$parentHeader"..name, BohemkaDKPLogFrame, "SecureHandlerClickTemplate");
    date:SetPoint(...)
    local dateFont = date:CreateFontString("$parentText","ARTWORK", "GameFontNormal")
    dateFont:SetText(text)
    dateFont:SetJustifyH(justify)
    dateFont:SetPoint("LEFT", 0, 0)
    dateFont:SetPoint("RIGHT", 0, 0)
    date:SetSize(width, 25)
    return date
end
function BohemkaDKP:CreateGuildFrameDKPButton()
    f = CreateFrame("BUTTON", "GuildFrameDKPButton", GuildFrame, "UIPanelButtonTemplate");
    f:SetPoint("LEFT", "GuildFrameControlButton", "RIGHT", 0, 0)
    f:SetText("DKP")
    if not CanEditPublicNote() then
        f:Disable()
    end
    f:SetScript("OnClick", function()
        BohemkaDKP.isEditMode = not BohemkaDKP.isEditMode
        BohemkaDKP:FixToggleButton()
        BohemkaDKP:RenderColumns()
    end)
    f:SetWidth(65)
    GuildFrameGuildInformationButton:ClearAllPoints(true)
    GuildFrameAddMemberButton:ClearAllPoints(true)
    GuildFrameControlButton:ClearAllPoints(true)
    GuildFrameGuildInformationButton:SetPoint("BOTTOMLEFT", "GuildFrame", 4, 4)
    GuildFrameAddMemberButton:SetPoint("LEFT", "GuildFrameGuildInformationButton", "RIGHT", 0, 0)
    GuildFrameControlButton:SetPoint("LEFT", "GuildFrameAddMemberButton", "RIGHT", 0, 0)
end
function BohemkaDKP:ShowEditModeButtons()
    for _, button in ipairs(self.editModeButtons) do
        _G[button]:Show()
    end
end
function BohemkaDKP:HideEditModeButtons()
    for _, button in ipairs(self.editModeButtons) do
        _G[button]:Hide()
    end
end
function BohemkaDKP:CreateGuildFrameProfessionButton(prefixName, size, relativeTo, ...)
    local prevProf
    for j = 1, PROFESSION_AMOUNT do
        local profFrame = CreateFrame("Frame", prefixName.."Frame"..j, relativeTo)
        profFrame:SetSize(size, size)

        profFrame:SetFrameStrata("HIGH")
        profFrame:SetScript("OnEnter", function(self)
            if self.tooltip then
                GameTooltip:SetOwner(self, "ANCHOR_TOP");
                GameTooltip:SetText(self.tooltip);
                GameTooltip:Show();
            end
        end)
        profFrame:SetScript("OnLeave", function()
            GameTooltip:Hide();
        end)
        profFrame:SetScript("OnMouseDown", function(self)
            if Crafts[self.playerName] then
                local crafts = Crafts[self.playerName][self.profession.name]
                if crafts then
                    BohemkaDKP:RenderCrafts(self.playerName, self.profession, crafts)
                    BohemkaDKP:ScrollToSelectedCraft()
                end
            end
        end)
        if not prevProf then
            profFrame:SetPoint(...)
        else
            local padding = 0
            if j == 5 then
                padding = 4
            end
            profFrame:SetPoint("LEFT", prevProf, "RIGHT", padding, 0)
        end

        font = profFrame:CreateFontString(prefixName.."Skill"..j,"OVERLAY", "GameFontNormalSmall")
        font:SetJustifyH("CENTER")
        font:SetAllPoints(profFrame)
        font:SetText("")
        font:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE")

        local prof = profFrame:CreateTexture("$parentProf", "ARTWORK")
        prof:SetAllPoints(profFrame)
        prof.parent = profFrame
        profFrame.font = font
        prevProf = profFrame
    end
end
function BohemkaDKP:CreateGuildFrameTalentsButton(i)
    local specContainer = CreateFrame("Frame", "GuildFrameSpecContainer"..i, _G["GuildFrameButton"..i])
    specContainer:SetSize(15,15)
    specContainer:SetPoint("RIGHT", "GuildFrameButton"..i.."Class", "RIGHT", -16, 0)
    local spec = specContainer:CreateTexture("$parentSpecIcon", "ARTWORK")
    spec:SetAllPoints(specContainer)
    specContainer:SetScript("OnEnter", function(self)
        if self.tooltip then
            GameTooltip:SetOwner(self, "ANCHOR_TOP");
            GameTooltip:SetText(self.tooltip);
            GameTooltip:Show();
        end
    end)
    specContainer:SetScript("OnLeave", function()
        GameTooltip:Hide();
    end)
end
function BohemkaDKP:CreateGuildFrameEditModeButtons()
    local buttonsWidth = 30
    local subtract = CreateFrame("Button", "ButtonSubtractAll", GuildFrame, "UIPanelButtonTemplate")
    subtract:SetPoint("LEFT", GuildFrameGuildListToggleButton, "RIGHT", 2, 0)
    subtract:SetWidth(buttonsWidth)
    subtract:SetText("-")
    subtract:RegisterForClicks("AnyUp")
    subtract:SetScript("OnClick", function()
        StaticPopup_Show("SUBTRACT_GUILDPLAYERDKP_MANY")
    end)
    subtract:Hide()

    local add = CreateFrame("Button", "ButtonAddAll", GuildFrame, "UIPanelButtonTemplate")
    add:SetPoint("LEFT", subtract, "RIGHT", 0, 0)
    add:SetWidth(buttonsWidth)
    add:SetText("+")
    add:RegisterForClicks("AnyUp")
    add:SetScript("OnClick", function()
        StaticPopup_Show("ADD_GUILDPLAYERDKP_MANY")
    end)
    add:Hide()

    f = CreateFrame("BUTTON", "SelectAllDKP", GuildFrame, "UIPanelButtonTemplate");
    f:SetText("Select All")
    f:SetWidth(80)
    f:Hide()
    f:SetPoint("LEFT", add, "RIGHT", 2, 0)
    f:SetScript("OnClick", function()
        BohemkaDKP.isSelectedAll = not BohemkaDKP.isSelectedAll
        BohemkaDKP:UpdateSelectedMembers()
    end)

end
function BohemkaDKP:UpdateSelectedMembers()
    local numMembers = BohemkaDKP:GetNumVisibleGuildMembers()
    for i=1, GetNumGuildMembers() do
        local fullName = GetGuildRosterInfo(i)
        if i <= numMembers then
            if BohemkaDKP.isSelectedAll then
                self.editModeSelected[fullName] = false
            end
            BohemkaDKP:SelectGuildMember(i, fullName, (BohemkaDKP.isSelectedAll and self.editModeSelected[fullName] ~= false) or self.editModeSelected[fullName])
        else
            BohemkaDKP:SelectGuildMember(i, fullName, false)
        end

    end
end
function BohemkaDKP:SelectGuildMember(index, fullName, state)
    if index <= GUILDMEMBERS_TO_DISPLAY then
        _G["GuildFrameDKPSelectButton"..index]:SetChecked(state)
    end
    if not fullName then
        return
    end
    BohemkaDKP.editModeSelected[fullName] = state
end
function BohemkaDKP:CreateGuildFrameProfessionsColumnHeader()
    local f = CreateFrame("BUTTON", "GuildFrameColumnHeader6", GuildFrame, "GuildFrameColumnHeaderTemplate");
    f:SetPoint("LEFT", "GuildFrameColumnHeader"..LAST_COLUMN_HEADER_INDEX, "RIGHT", -2, 0)
    f:SetText("Professions")
    f:SetScript("OnMouseDown", function()
        GuildCraftListFrame:Show()
        BohemkaDKP:PositionGuildCraftFrame()
        BohemkaDKP:RenderCraftsMulti()
    end)
    WhoFrameColumn_SetWidth(GuildFrameColumnHeader6, GUILD_FRAME_COLUMN_WIDTH_PROFESSIONS)
end
function BohemkaDKP:CreateGuildFrameGuildStatusNoteColumnHeader()
    local f = CreateFrame("BUTTON", "GuildFrameGuildStatusColumnHeader5", GuildStatusFrame, "GuildFrameColumnHeaderTemplate");
    f:SetPoint("LEFT", "GuildFrameGuildStatusColumnHeader2", "RIGHT", -2, 0)
    f:SetText("Note")
    f:Disable()
    WhoFrameColumn_SetWidth(f, GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_NOTE)
    _G["GuildFrameGuildStatusColumnHeader4"]:SetPoint("LEFT", "GuildFrameGuildStatusColumnHeader5", "RIGHT", -2, 0)
end
function BohemkaDKP:RefreshDKPColumn(index, fullName, note, online)
    local btn = _G["GuildFrameGuildStatusButton"..index.."Note"]
    local dkp = self:NoteDKPToNumber(note)
    if not dkp then
        return
    end
    if self.cheaters[fullName] then
        dkp = self:colorize(dkp, self.COLOR.RED)
    elseif online then
        btn:SetTextColor(1.0, 1.0, 1.0)
    elseif not online then
        btn:SetTextColor(0.5, 0.5, 0.5)
    end
    btn:SetText(dkp)
end
function BohemkaDKP:AdjustGuildFramesAfterUpdate()
    --GuildMOTDEditButton:Enable()
    self:OnUpdateCompatibilityCallback()
    self:RenderColumns()
    self:UpdateSelectedMembers()
    if CanEditMOTD() then
        GuildFrameFakeMOTD:Hide()
    else
        GuildFrameFakeMOTD:SetText(GuildFrameNotesText:GetText())
        GuildFrameFakeMOTD:Show()
    end


    WhoFrameColumn_SetWidth(GuildFrameGuildStatusColumnHeader3, GUILD_FRAME_COLUMN_WIDTH_DKP)

    local guildOffset = FauxScrollFrame_GetOffset(GuildListScrollFrame);
    local numMembers = self:GetNumVisibleGuildMembers()
    for i=1, GUILDMEMBERS_TO_DISPLAY, 1 do
        local guildIndex = guildOffset + i;
        local fullName, _, _, _, _, _, note, officerNote, online, _, classFileName = GetGuildRosterInfo(guildIndex);
        local professions
        _G["GuildFrameDKPSelectButton"..i]:SetChecked(self.editModeSelected[fullName])
        if i <= numMembers then
            _G["GuildFrameGuildStatusButton"..i.."OfficerNote"]:SetText(officerNote)
            self:RefreshDKPColumn(i, fullName, note, online)

            if online then
                if classFileName then
                    local color = RAID_CLASS_COLORS[classFileName]
                    _G["GuildFrameButton"..i.."Class"]:SetTextColor(color.r, color.g, color.b)
                end
            end
            professions = self:GetPlayerProfessions(fullName)
        else
            _G["GuildFrameGuildStatusButton"..i.."OfficerNote"]:SetText("")
            _G["GuildFrameGuildStatusButton"..i.."Note"]:SetText("")
            professions = {}
        end
        self:RenderProfessions("GuildFrameProf"..i.."Frame%dProf", fullName, professions)


        _G["GuildFrameGuildStatusButton"..i.."Note"]:SetWidth(GUILD_FRAME_COLUMN_WIDTH_DKP)


        if FriendsFrame.playerStatusFrame then
            _G["GuildFrameProfContainer"..i]:SetPoint( "LEFT", _G["GuildFrameButton"..i..LAST_COLUMN_HEADER_NAME], "RIGHT", -6, 0)
        else
            _G["GuildFrameProfContainer"..i]:SetPoint( "LEFT", _G["GuildFrameGuildStatusButton"..i.."Online"], "RIGHT", -6, 0)
        end
        local _, spec, amounts = self:GetPlayerTalents(fullName)
        local specFrame = _G["GuildFrameSpecContainer"..i]
        local specIcon = _G["GuildFrameSpecContainer"..i.."SpecIcon"]
        if spec then
            local tooltip = table.concat(amounts, "/")
            specIcon:SetTexture(spec.icon)
            specFrame.tooltip = tooltip
            specFrame:Show()
        else
            specIcon:SetTexture(nil)
            specFrame.tooltip = nil
            specFrame:Hide()
        end
        self:RenderMainCharacterInfo(i, fullName)

    end
    if FriendsFrame.playerStatusFrame then
        GuildFrameColumnHeader6:SetPoint("LEFT", "GuildFrameColumnHeader"..LAST_COLUMN_HEADER_INDEX, "RIGHT", -2, 0)
    else
        GuildFrameColumnHeader6:SetPoint("LEFT", "GuildFrameGuildStatusColumnHeader4", "RIGHT", -2, 0)
    end
end
function BohemkaDKP:RenderMainCharacterInfo(i, fullName)
    local charData = self:GetGuildMemberCharactersData(fullName)
    local name, rank = self:GetMainCharacter(charData)
    if name and name ~= fullName then
        _G["GuildFrameButton"..i].tooltip = self:AddClassColorToName(name).." - "..rank
        _G["GuildFrameButton"..i.."Name"]:SetAlpha(0.75)
    else
        _G["GuildFrameButton"..i].tooltip = nil
        _G["GuildFrameButton"..i.."Name"]:SetAlpha(1)
    end
end
function BohemkaDKP:RenderColumns()
    local relativeTo, relativeToCol
    local width = self:GetFriendsFrameWidth() - 18
    if BohemkaDKPConfig.showProfessions then
        GuildFrameColumnHeader6:Show()
        relativeTo = GuildFrameColumnHeader6
    else
        GuildFrameColumnHeader6:Hide()
        relativeTo = _G["GuildFrameColumnHeader"..LAST_COLUMN_HEADER_INDEX]
    end

    if BohemkaDKPConfig.showDKP then
        GuildFrameGuildStatusColumnHeader3:Show()
        GuildFrameDKPButton:Show()
    else
        GuildFrameGuildStatusColumnHeader3:Hide()
        GuildFrameDKPButton:Hide()
    end

    if self.isEditMode and BohemkaDKPConfig.showDKP then
        self:ShowEditModeButtons()
    else
        self:HideEditModeButtons()
    end

    GuildFrameGuildStatusColumnHeader3:SetPoint("LEFT", relativeTo, "RIGHT", -2, 0)
    local numMembers = self:GetNumVisibleGuildMembers()
    local showScrollBar;
    if ( numMembers > GUILDMEMBERS_TO_DISPLAY ) then
        showScrollBar = 1;
    end

    if showScrollBar then
        width = width - 23
    end
    for i=1, GUILDMEMBERS_TO_DISPLAY, 1 do
        local prof = _G["GuildFrameProfContainer"..i]
        local dkp = _G["GuildFrameGuildStatusButton"..i.."Note"]

        local pointX
        local dkpCheckButton = _G["GuildFrameDKPSelectButton"..i]
        if self.isEditMode and BohemkaDKPConfig.showDKP then
            pointX = -12
            dkpCheckButton:SetPoint("LEFT", "GuildFrameGuildStatusButton"..i.."Note", "RIGHT", 2, 0)
            if i <= numMembers then
                dkpCheckButton:Show()
            else
                dkpCheckButton:Hide()
            end
        else
            pointX = 0
            dkpCheckButton:Hide()
        end

        if BohemkaDKPConfig.showProfessions then
            prof:Show()
            relativeToCol = _G["GuildFrameProf"..i.."Frame"..PROFESSION_AMOUNT]
            dkp:SetPoint("LEFT", relativeToCol, "RIGHT", -2 + pointX, 0)
        else
            prof:Hide()
            relativeToCol = _G["GuildFrameButton"..i..LAST_COLUMN_HEADER_NAME]
            dkp:SetPoint("LEFT", relativeToCol, "RIGHT", -18 + pointX, 0)
        end
        if BohemkaDKPConfig.showDKP then
            dkp:Show()
        else
            dkp:Hide()
        end

        self:AdjustGuildFrameButtonWidth(i, width)
    end
    local tabIndex = PanelTemplates_GetSelectedTab(FriendsFrame)
    if tabIndex == 3 then
        local w = BohemkaDKP:GetFriendsFrameWidth()
        if not InCombatLockdown() then
            FriendsFrame:SetWidth(w)
            GuildListScrollFrame:SetWidth(w - 30)
        end
    end
    GuildFrameNotesText:SetWidth(FriendsFrame:GetWidth() - 20)
    self:FixToggleButton()
end
function BohemkaDKP:FixToggleButton()
    GuildFrameGuildListToggleButton:ClearAllPoints()
    local totalMembers, onlineMembers, _ = GetNumGuildMembers();
    local numGuildMembers = 0;
    local showOffline = GetGuildRosterShowOffline();
    if (showOffline) then
        numGuildMembers = totalMembers;
    else
        numGuildMembers = onlineMembers;
    end
    local diff = 0
    local noteWidth = 75
    local noteHeaderWidth = GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_NOTE
    local onlineButtonWidth = GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE
    if numGuildMembers <= GUILDMEMBERS_TO_DISPLAY then
        diff = 25
        noteHeaderWidth = 90
        noteWidth = 85
        onlineButtonWidth = GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE_NO_SCROLL
    end
    WhoFrameColumn_SetWidth(GuildFrameGuildStatusColumnHeader5, noteHeaderWidth)
    for i=1, GUILDMEMBERS_TO_DISPLAY, 1 do
        local officerNoteButton = getglobal("GuildFrameGuildStatusButton"..i.."OfficerNote")
        officerNoteButton:SetWidth(noteWidth)
        local onlineButton = getglobal("GuildFrameGuildStatusButton"..i.."Online")
        onlineButton:SetWidth(onlineButtonWidth)
    end

    local padding = 0
    if self.isEditMode and BohemkaDKPConfig.showDKP then
        padding = -145
    end
    GuildFrameGuildListToggleButton:SetPoint("BOTTOMRIGHT", "GuildListScrollFrame", padding + diff, 0);
end
function BohemkaDKP:UpdateAuctionUIState()
    if self.currentItem then
        self:UpdateBidButtonState()
        if self:IsPlayerAuctionOwner() then
            self:ValidateBidderDKP()
        end
    end
end
function BohemkaDKP:UpdateUIGuildPermissions()
    if CanEditPublicNote() then
        DetailFrameDKPFrame.add:Show()
        DetailFrameDKPFrame.subtract:Show()
        GuildFrameDKPButton:Enable()
    else
        DetailFrameDKPFrame.add:Hide()
        DetailFrameDKPFrame.subtract:Hide()
        GuildFrameDKPButton:Disable()
    end
end
function BohemkaDKP:UpdateDetailFrame()
    local detailFrameHeight = GUILD_DETAIL_NORM_HEIGHT + 20
    local fullName, rank, _, _, _, _, note, _, _ = GetGuildRosterInfo(GetGuildRosterSelection());
    local isCombat = InCombatLockdown()
    if ( GetGuildRosterSelection() > 0 ) then
        GuildMemberDetailNoteLabel.dkp:SetText(self:NoteDKPToNumber(note))
        local professions = self:GetPlayerProfessions(fullName)
        if #professions > 0 then
            detailFrameHeight = GUILD_DETAIL_OFFICER_HEIGHT
        end
        GuildMemberDetailName:SetText(self:AddClassColorToName(fullName))
        self:RenderProfessions("DetailFrameProfFrame%dProf", fullName, professions, true)
        local charData = self:GetGuildMemberCharactersData(fullName)
        local name, rankMain = BohemkaDKP:GetMainCharacter(charData)
        if name and name ~= fullName then
            GuildMemberDetailName:SetText(format("%s (%s)", GuildMemberDetailName:GetText(), self:AddClassColorToName(name)))
            GuildMemberDetailRankText:SetText(format("%s %s", rank, self:colorize(format("(%s)", self:colorize(rankMain, self.COLOR.WHITE)), self.COLOR.NORMAL)))
        end
    elseif not isCombat then
        GuildMemberDetailFrame:Hide()
    end
    if not isCombat then
        GuildMemberDetailFrame:SetHeight(detailFrameHeight)
    end
    BohemkaDKP:RefreshDKPLog(fullName)
end
function BohemkaDKP:RefreshDKPLog(fullName)
    local sortedLog = self:GetSortedLog(fullName, "DESC")
    sortedLog = self:FillExternalEdit(sortedLog, fullName)
    self.sortedLog = sortedLog
    FauxScrollFrame_Update(BohemkaDKPLogFrameScrollFrame, #sortedLog, DKP_LOG_ROW_AMOUNT, DKP_LOG_ROW_HEIGHT)

    --for i=1, DKP_LOG_ROW_AMOUNT do
    --    local descFrame = _G["BohemkaDKPLogFrameRow"..i.."DescFrameDesc"]
    --    if #sortedLog > DKP_LOG_ROW_AMOUNT then
    --        descFrame:SetWidth(DKP_LOG_REASON_WIDTH - 10)
    --        BohemkaDKPLogFrameHeaderReason:SetWidth(DKP_LOG_REASON_WIDTH - 10)
    --    else
    --        descFrame:SetWidth(DKP_LOG_REASON_WIDTH)
    --        BohemkaDKPLogFrameHeaderReason:SetWidth(DKP_LOG_REASON_WIDTH)
    --    end
    --end

    self:UpdateDKPLog()
end
function BohemkaDKP:UpdateDKPLog()
    local logOffset = FauxScrollFrame_GetOffset(BohemkaDKPLogFrameScrollFrame)
    local fullName = GetGuildRosterInfo(GetGuildRosterSelection());
    local sortedLog = self.sortedLog
    for i=1, DKP_LOG_ROW_AMOUNT do
        local index = i + logOffset
        local row = _G["BohemkaDKPLogFrameRow"..i]
        local descFrame = _G["BohemkaDKPLogFrameRow"..i.."DescFrame"]
        if sortedLog[index] then
            row:Show()
            local dateCol = _G["BohemkaDKPLogFrameRow"..i.."Date"]
            local net = _G["BohemkaDKPLogFrameRow"..i.."Net"]
            local deltaCol = _G["BohemkaDKPLogFrameRow"..i.."Delta"]
            local desc = _G["BohemkaDKPLogFrameRow"..i.."DescFrameDesc"]
            local owner = _G["BohemkaDKPLogFrameRow"..i.."Owner"]

            local dateFormat
            if sortedLog[index].time and sortedLog[index].time > 1 and not sortedLog[index].external and not string.find(sortedLog[index].reason, 'Data restored from') then
                local since = GetServerTime() - sortedLog[index].time
                if since <= 24*60*60 then
                    dateFormat = "%H:%M"
                elseif since <= 24*60*60*7 then
                    dateFormat = "%a %H:%M"
                elseif since <= 24*60*60*365 then
                    dateFormat = '%m/%d %H:%M'
                else
                    dateFormat = '%Y/%m/%d %H:%M'
                end
                dateCol:SetText(date(dateFormat, sortedLog[index].time))
            else
                dateCol:SetText("-")
            end
            local reason = sortedLog[index].reason
            local isExternal = false
            if reason == "External edit" then
                reason = self:colorize(reason, self.COLOR.RED)
                isExternal = true
            elseif reason == "" then
                reason = self:colorize("-", self.COLOR.GRAY)
            elseif reason == "Initial DKP" then
                reason = self:colorize(reason, self.COLOR.YELLOW)
            elseif reason:match('^killing of') then
                local bossName = reason:match('^killing of (.+)')
                reason = self:colorize("|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8:12:12:0:0|t "..bossName, self.COLOR.DARKRED)
            end
            local tooltip = reason
            if reason:match('\|Hitem:%d+:') then
                tooltip = nil
                descFrame.itemLink = reason
            else
                descFrame.itemLink = nil
            end
            net:SetText(self:ColorizeValue(sortedLog[index].current))
            local delta = sortedLog[index].current - sortedLog[index].prev
            deltaCol:SetText(self:ColorizeValue(delta))
            desc:SetText(reason)

            if sortedLog[index].reverted then
                row:SetAlpha(.5)
            else
                row:SetAlpha(1)
            end

            local assignee = sortedLog[index].editor
            if assignee then
                assignee = self:AddClassColorToName(assignee)
            end
            owner:SetText(assignee or "-")
            if #reason > 25 then
                descFrame.tooltip = tooltip
            else
                descFrame.tooltip = nil
            end
            descFrame.enableDropdown = isExternal
            descFrame:Show()
        else
            row:Hide()
            descFrame:Hide()
        end
        descFrame.item = sortedLog[index]
        descFrame.index = index
        descFrame.fullName = fullName
    end
end
function BohemkaDKP:ColorizeValue(value)
    if value > 0 then
        color = self.COLOR.GREEN
    elseif value < 0 then
        color = self.COLOR.RED
    else
        color = self.COLOR.WHITE
    end
    return self:colorize(value, color)
end
function BohemkaDKP:CreateAuctionFrame()
    local containerWidth = 210
    local container =  CreateFrame("Frame", "BohemkaDKPAuctionFrame", UIParent, BackdropTemplateMixin and "BackdropTemplate" or nil)
    local pos = BohemkaDKPConfig.position or {}
    container:SetPoint(pos.point or "CENTER", pos.x, pos.y)
    container:SetWidth(containerWidth)
    container:SetHeight(219)
    container:SetBackdrop(BACKDROP_DIALOG_32_32)
    container:SetMovable(true)
    container:EnableMouse(true)
    container:SetUserPlaced(true)
    container:RegisterForDrag("LeftButton")
    container:SetScript("OnDragStart", container.StartMoving)
    container:SetScript("OnDragStop", function()
        local point, _, _, xOfs, yOfs = container:GetPoint()
        BohemkaDKPConfig.position = {
            x = xOfs,
            y = yOfs,
            point = point
        }
        container:StopMovingOrSizing()
    end)
    container:Hide()
    self.frames.auction = container


    local f2 = CreateFrame("BUTTON", "AuctionDKPClose", container, "UIPanelCloseButton");
    f2:SetPoint("TOPRIGHT", container, "TOPRIGHT", -4, -4)
    f2:HookScript("OnClick", function()
        BohemkaDKP:Pass()
    end)

    local frameHeader = container:CreateTexture("$parentHeader", "OVERLAY")
    frameHeader:SetPoint("TOP", 0, 12)
    frameHeader:SetTexture(131080) -- "Interface\\DialogFrame\\UI-DialogBox-Header"
    frameHeader:SetSize(290, 64)

    local frameHeaderText = container:CreateFontString("$parentHeaderText", "OVERLAY", "GameFontNormal")
    frameHeaderText:SetPoint("TOP", frameHeader, 0, -14)
    frameHeaderText:SetText("Auction")

    container.paper = container:CreateTexture(nil, "ARTWORK")
    container.paper:SetPoint("TOPLEFT", 11, -11)
    container.paper:SetWidth(257)
    container.paper:SetHeight(138)
    container.paper:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-Reputation-DetailBackground")
    -- container.paper:SetColorTexture(0, 0, 0, 1)

    container.divider = container:CreateTexture(nil, "OVERLAY")
    container.divider:SetPoint("TOPLEFT", 9, -139)
    container.divider:SetWidth(256)
    container.divider:SetHeight(32)
    container.divider:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Divider")



    local a = CreateFrame("Frame", "$parentStatusBarContainer", container, BackdropTemplateMixin and "BackdropTemplate" or nil)
    a:SetSize(137, 21)
    a:SetPoint("TOP", 0, -25)
    a:SetBackdrop({
        bgFile   = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 12,
        insets = { left = 3, right = 3, top = 3, bottom = 3, },
    })
    a:SetBackdropColor(0, 0, 0, 0.7)
    a:SetBackdropBorderColor(0.2, 0.2, 0.2)
    a:Hide()

    container.statusBar = CreateFrame("StatusBar", "$parentStatusBar", a)
    container.statusBar:SetPoint("TOPLEFT", 4, -4)
    container.statusBar:SetPoint("TOPRIGHT", -4, 6)
    container.statusBar:SetWidth(137)
    -- container.statusBar:SetFrameStrata("HIGH")
    container.statusBar:SetHeight(13)
    container.statusBar:SetMinMaxValues(0, BohemkaDKP.currentTime)
    container.statusBar:SetValue(BohemkaDKP.currentTime)
    container.statusBar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
    container.statusBar.parent = a

    font = container.statusBar:CreateFontString(nil,"ARTWORK", "GameFontHighlightSmall")
    font:SetJustifyH("CENTER")
    font:SetPoint("CENTER")
    font:SetText("60")
    font:SetTextColor(1, 0.82, 0)

    container.item =  CreateFrame("BUTTON", "AuctionFrameItem", container, "LootButtonTemplate")
    container.item:SetPoint("TOPLEFT", a, "BOTTOMLEFT", -7, -5)
    container.item:SetHitRectInsets(0, -107, 0, 0)
    container.item:SetScript("OnClick", nil)
    container.item:SetScript("OnUpdate", nil)
    container.item:SetScript("OnEnter", function(self)
        if not BohemkaDKP.currentItem then
            return
        end
        GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
        itemName, itemLink = GetItemInfo(BohemkaDKP.currentItem.id)
        GameTooltip:SetHyperlink(itemLink)
        GameTooltip:Show();
    end)

    container.statusBar.font = font

    local price = container.item:CreateFontString(nil,"ARTWORK", "GameFontHighlightLarge")
    price:SetJustifyH("CENTER")
    price:SetPoint("TOPLEFT", container.item, "BOTTOMLEFT", 0, -13)
    price:SetText("Price:")
    price:SetTextColor(1, 0.82, 0)

    local priceValue = container.item:CreateFontString("AuctionItemPriceValue","ARTWORK", "GameFontHighlightLarge")
    priceValue:SetJustifyH("LEFT")
    priceValue:SetPoint("LEFT", price, "RIGHT", 5, 0)
    priceValue:SetText("100")
    priceValue:SetWidth(100)
    priceValue:SetTextColor(1, 0.82, 0)
    container.item.priceValue = priceValue

    local e = CreateFrame("EditBox", "BidValue", container, "InputBoxTemplate")
    e:SetWidth(70)
    e:SetHeight(33)
    e:SetPoint("BOTTOM", 2, 7)
    e:SetFontObject("GameFontHighlight")
    e:SetTextInsets(5,8,0,0)
    e:SetMultiLine(false)
    e:SetAutoFocus(false)
    e:SetNumeric(true)
    e:SetJustifyH("CENTER")
    e:SetScript( "OnEscapePressed", function( )
        e:ClearFocus()
    end )
    e:SetText("10")
    e:SetScript("OnEnterPressed", function(self)
        self:ClearFocus()
        BohemkaDKP:Bid(tonumber(self:GetText()))
    end)
    e:SetScript("OnChar", function(self)
        self.isChanged = true
    end)


    local btn = CreateFrame("Button", "BidButton", container, "UIPanelButtonTemplate")
    btn:SetPoint("BOTTOMRIGHT", container, -10, 10)
    btn:SetSize(56, 28)
    btn:SetText("Bid")
    btn:RegisterForClicks("AnyUp")
    btn:SetScript("OnClick", function()
        BohemkaDKP:Bid(e:GetNumber())
        e:ClearFocus()
        e.isChanged = false
    end)

    container.bid = btn

    local pass = CreateFrame("Button", "ButtonPass", container, "UIPanelButtonTemplate")
    pass:SetPoint("BOTTOMLEFT", 10, 10)
    pass:SetSize(56, 28)
    pass:SetText("Pass")
    pass:RegisterForClicks("AnyUp")
    pass:SetScript("OnClick", function()
        e:ClearFocus()
        BohemkaDKP:Pass()
    end)

    container.pass = pass
    local highestBidderFrame = CreateFrame("Frame", "$parentHighestBidderFrame", container)
    highestBidderFrame:SetPoint("TOPLEFT", price, "BOTTOMLEFT", 0, -3)
    highestBidderFrame:SetSize(container:GetWidth() - 45, 15)
    highestBidderFrame:SetScript("OnEnter", function(self)
        if self.tooltip then
            GameTooltip:SetOwner(self, "ANCHOR_TOP");
            GameTooltip:SetText(self.tooltip);
            GameTooltip:Show();
        end
    end)
    highestBidderFrame:SetScript("OnLeave", function()
        GameTooltip:Hide();
    end)
    local highestBidder = highestBidderFrame:CreateFontString(nil,"ARTWORK", "GameFontHighlight")
    highestBidder:SetJustifyH("LEFT")
    highestBidder:SetAllPoints(highestBidderFrame)
    highestBidder:SetText("Highest bid:")
    highestBidder:SetTextColor(1, 0.82, 0)
    highestBidder:Hide()
    highestBidder.frame = highestBidderFrame
    container.highestBidder = highestBidder

    local currentDKP = container:CreateFontString(nil,"ARTWORK", "GameFontNormal")
    currentDKP:SetJustifyH("RIGHT")
    currentDKP:SetPoint("BOTTOMRIGHT", btn, "TOPRIGHT", -13, 4)
    currentDKP:SetText("")

    local arrow = container:CreateTexture("$parentArrow", "ARTWORK")
    arrow:SetPoint("BOTTOM", 0, 44)
    arrow:SetTexture("Interface\\Glues\\Common\\Glue-RightArrow-Button-Up") -- "Interface\\DialogFrame\\UI-DialogBox-Header"
    arrow:SetSize(24, 24)

    local currentDKPValue = container:CreateFontString(nil,"ARTWORK", "GameFontHighlight")
    currentDKPValue:SetJustifyH("LEFT")
    currentDKPValue:SetPoint("LEFT", arrow, "RIGHT", 5, 0)
    currentDKPValue:SetText("0")
    container.currentDKPValue = currentDKPValue

    local b = container:CreateFontString(nil,"ARTWORK", "GameFontNormal")
    b:SetJustifyH("CENTER")
    b:SetPoint("RIGHT", arrow, "LEFT", -5, 0)
    b:SetText("0")
    container.totalDKPValue = b

    local divider2 = container:CreateTexture(nil, "OVERLAY")
    divider2:SetPoint("TOPLEFT", 9, -169)
    divider2:SetWidth(256)
    divider2:SetHeight(32)
    divider2:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Divider")

    local marble = container:CreateTexture(nil, "BACKGROUND")
    marble:SetPoint("TOPLEFT", container.divider, "TOPLEFT", 0, -5)
    marble:SetWidth(containerWidth - 20)
    marble:SetHeight(70)
    marble:SetTexture("Interface\\FrameGeneral\\UI-Background-Marble")

    local lootMasterFrameWidth = 213
    local lootMasterFrame = CreateFrame("Frame", "LootMasterFrame", container, BackdropTemplateMixin and "BackdropTemplate" or nil)
    lootMasterFrame:SetPoint("TOPLEFT", container, "TOPRIGHT", -12, 0)
    lootMasterFrame:SetWidth(lootMasterFrameWidth)
    lootMasterFrame:SetHeight(219)
    lootMasterFrame:SetBackdrop(BACKDROP_DIALOG_32_32)
    lootMasterFrame:Hide()

    container.lootMasterFrame = lootMasterFrame

    local bg = lootMasterFrame:CreateTexture(nil, "ARTWORK")
    bg:SetPoint("TOPLEFT", 12, -12)
    bg:SetPoint("BOTTOMRIGHT", -12, 12)
    bg:SetTexture("Interface\\FrameGeneral\\UI-Background-Rock")

    local f = CreateFrame("BUTTON", "BidderNameHeader1", lootMasterFrame, "GuildFrameColumnHeaderTemplate");
    f:SetPoint("TOPLEFT", 11, -12)
    f:SetText("Name")
    WhoFrameColumn_SetWidth(f, 105)

    f2 = CreateFrame("BUTTON", "BidderNameHeader2", lootMasterFrame, "GuildFrameColumnHeaderTemplate");
    f2:SetPoint("LEFT", f, "RIGHT", 0, 0)
    f2:SetText("Bid")
    WhoFrameColumn_SetWidth(f2, 43)

    local f3 = CreateFrame("BUTTON", "BidderNameHeader3", lootMasterFrame, "GuildFrameColumnHeaderTemplate");
    f3:SetPoint("LEFT", f2, "RIGHT", 0, 0)
    f3:SetText("DKP")
    WhoFrameColumn_SetWidth(f3, 43)

    local lootMasterFrameBg = CreateFrame("Frame", "LootMasterFrameBG", lootMasterFrame, "InsetFrameTemplate")
    lootMasterFrameBg:SetPoint("TOPLEFT", 10, -33)
    lootMasterFrameBg:SetPoint("BOTTOMRIGHT", -10, 10)

    local award = CreateFrame("Button", "ButtonLMAward", lootMasterFrame, "UIPanelButtonTemplate")
    award:SetPoint("BOTTOMRIGHT", -15, 16)
    award:SetSize(56, 28)
    award:SetText("Award")
    award:Disable()
    award:RegisterForClicks("AnyUp")
    award:SetScript("OnClick", function()
        BohemkaDKP:EndAuction()
    end)
    lootMasterFrame.award = award

    local prevFrame
    for i = 1, BIDDER_TABLE_SIZE do
        local frameName = "LootMasterFrameBidder"..i
        local bidder = CreateFrame("Button", frameName, lootMasterFrame)
        bidder:SetNormalTexture("Interface\\GuildFrame\\GuildFrame")
        bidder:GetNormalTexture():SetTexCoord(0.36230469, 0.38183594, 0.95898438, 0.99804688)
        bidder:SetHighlightTexture("Interface\\FriendsFrame\\UI-FriendsFrame-HighlightBar")
        bidder.Reset = function(self)
            self:Hide()
            self:UnlockHighlight()
            self.selected = false
        end
        bidder:SetSize(lootMasterFrameWidth - 31, 18)
        bidder:SetScript("OnClick", function(self)
            for j = 1, BIDDER_TABLE_SIZE do
                local frame = _G["LootMasterFrameBidder"..j]
                if frame ~= bidder then
                    frame:UnlockHighlight()
                    frame.selected = false
                end
            end
            if not self.selected then
                self:LockHighlight()
                self.selected = true
            else
                self:UnlockHighlight()
                self.selected = false
            end
            BohemkaDKP:UpdateWinner()
        end)
        local bidderName = bidder:CreateFontString(frameName.."Name","ARTWORK", "GameFontNormalSmall")
        bidderName:SetJustifyH("LEFT")
        bidderName:SetPoint("LEFT", 5, 0)
        bidderName:SetText("")
        local bidderDKP = bidder:CreateFontString(frameName.."DKP","ARTWORK", "GameFontNormalGraySmall")
        bidderDKP:SetJustifyH("RIGHT")
        bidderDKP:SetPoint("RIGHT", -5, 0)
        bidderDKP:SetText("1850")
        bidderDKP:SetWidth(38)
        local bidderValue = bidder:CreateFontString(frameName.."Value","ARTWORK", "GameFontNormalSmall")
        bidderValue:SetJustifyH("RIGHT")
        bidderValue:SetPoint("RIGHT", bidderDKP, "LEFT", 0, 0)
        bidderValue:SetText()

        if prevFrame then
            bidder:SetPoint("TOP", prevFrame, "BOTTOM", 0, 0)
        else
            bidder:SetPoint("TOP", lootMasterFrameBg, "TOP", 0, -4)
        end
        prevFrame = bidder
        bidder.name = bidderName
        bidder.value = bidderValue
        bidder.dkp = bidderDKP
        bidder:Hide()
    end

    local divider3 = lootMasterFrameBg:CreateTexture(nil, "OVERLAY")
    divider3:SetPoint("TOPLEFT", prevFrame, "BOTTOMLEFT", -3, 4)
    divider3:SetWidth(250)
    divider3:SetHeight(32)
    divider3:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Divider")

    local cancel = CreateFrame("Button", "ButtonLMCancel", lootMasterFrame, "UIPanelButtonTemplate")
    cancel:SetPoint("BOTTOMLEFT", 15, 16)
    cancel:SetSize(56, 28)
    cancel:SetText("Cancel")
    cancel:RegisterForClicks("AnyUp")
    cancel:SetScript("OnClick", function()
        if BohemkaDKP.countdownActive then
            BohemkaDKP:CancelAuctionCountdown()
            return
        end
        BohemkaDKP.currentItemWinner = nil
        BohemkaDKP:EndAuction()

    end)




    --local btn = CreateFrame("Button", nil, UIParent, "UIPanelButtonTemplate")
    --btn:SetPoint("CENTER")
    --btn:SetSize(56, 28)
    --btn:SetText("Transfer")
    --btn:RegisterForClicks("AnyUp")
    --btn:SetScript("OnClick", function()
    --    local totalMembers, onlineMembers, onlineAndMobileMembers = GetNumGuildMembers();
    --    local tmp = {}
    --    for i,v in ipairs({strsplit("\n", BohemkaDKP.cDKP)}) do
    --        local name, class, dkp = strsplit(",", v)
    --        tmp[name] = tonumber(dkp)
    --    end
    --    for i = 1, totalMembers do
    --        fullName, rank, rankIndex, level, class, zone, note, officernote, online, isAway = GetGuildRosterInfo(i);
    --        local importedDKP = tmp[strsplit("-", fullName)]
    --        -- print("IMPORTING DKP", fullName, importedDKP, string.format("%05d", importedDKP or ""))
    --        if importedDKP then
    --            BohemkaDKP:SaveDKP(i, importedDKP)
    --        end
    --    end
    --end)
end
function BohemkaDKP:GetTimerColor(value, maxValue)
    local prc = (100 / maxValue) * value
    for _, c in pairs(BohemkaDKPConfig.timerColors) do
        if prc >= c[1] then
            return c[2]
        end
    end
end
function BohemkaDKP:UpdateBidderTable()
    if not self.bidHistory then
        return
    end
    self.sortedHistory = {}
    for name, bid in pairs(self.bidHistory) do
        if bid ~= nil then
            table.insert(self.sortedHistory, {name=name, bid=bid})
        end
    end
    table.sort(self.sortedHistory, function(a,b) return a.bid > b.bid end)
    for i = 1, BIDDER_TABLE_SIZE do
        local btn = _G["LootMasterFrameBidder"..i]
        local bidder = self.sortedHistory[i]
        if not bidder then
            btn:Reset()
        else
            local name = self:AddClassColorToName(bidder.name)
            btn.name:SetText(strsplit("-", name))
            btn.value:SetText( bidder.bid)
            local delta = self:GetCurrentDKP(bidder.name) - self.currentItem.price
            local font
            if delta == 0 then
                font = "GameFontRedSmall"
            elseif delta < 0 then
                font = "GameFontNormalGraySmall"
            else
                font = "GameFontHighlightSmall"
            end
            btn.dkp:SetFontObject(font)
            btn.dkp:SetText(delta)
            btn:Show()
        end
    end
end
function BohemkaDKP:RefreshTotalDKP()
    local currentDKP = self:GetCurrentDKP()
    self.frames.auction.totalDKPValue:SetText(currentDKP)
    if self.currentItem and self.currentItem.price then
        BohemkaDKP:SetCurrentDKPValue(currentDKP - self.currentItem.price)
    end

end
function BohemkaDKP:SetCurrentDKPValue(value)
    if value <= 0 then
        value = BohemkaDKP:colorize(value, BohemkaDKP.COLOR.RED)
    end
    self.frames.auction.currentDKPValue:SetText(value)
end
function BohemkaDKP:GetDKPFromEditBox(editBox)
    local text = editBox:GetText()
    local dkp, reason = strsplit(" ", text, 2)
    local percent = false
    if dkp:sub(-1) == "%" then
        dkp = dkp:sub(1, -2)
        percent = true
    end
    return tonumber(dkp), reason, percent
end
function BohemkaDKP:SetDKPFromEditBox(editBox)
    local dkp, reason, percent = self:GetDKPFromEditBox(editBox)
    BohemkaDKP:SetDKP(GetGuildRosterSelection(), dkp, "GUILD", reason, percent)
end
function BohemkaDKP:AddDKPFromEditBox(editBox)
    local dkp, reason, percent = self:GetDKPFromEditBox(editBox)
    BohemkaDKP:AddDKP(GetGuildRosterSelection(), dkp, "GUILD", reason, percent)
end
function BohemkaDKP:SubtractDKPFromEditBox(editBox)
    local dkp, reason, percent = self:GetDKPFromEditBox(editBox)
    BohemkaDKP:SubtractDKP(GetGuildRosterSelection(), dkp, "GUILD", reason, percent)
end
function BohemkaDKP:AddStaticPopups()
    StaticPopupDialogs["SET_GUILDPLAYERDKP"] = {
        text = "Set DKP",
        button1 = ACCEPT,
        button2 = CANCEL,
        hasEditBox = 1,
        maxLetters = 150,
        wide = true,
        editBoxWidth = 200,
        OnAccept = function(self)
            BohemkaDKP:SetDKPFromEditBox(self.editBox)
        end,
        OnShow = function(self)
            --Sets the text to the 7th return from GetGuildRosterInfo(GetGuildRosterSelection());
            self.editBox:SetText(BohemkaDKP:NoteDKPToNumber(select(7, GetGuildRosterInfo(GetGuildRosterSelection()))));
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self)
            local parent = self:GetParent();
            BohemkaDKP:SetDKPFromEditBox(parent.editBox)
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        hideOnEscape = 1
    };
    StaticPopupDialogs["SUBTRACT_GUILDPLAYERDKP"] = {
        text = "Subtract DKP",
        button1 = ACCEPT,
        button2 = CANCEL,
        hasEditBox = 1,
        maxLetters = 150,
        wide = true,
        editBoxWidth = 200,
        OnAccept = function(self)
            BohemkaDKP:SubtractDKPFromEditBox(self.editBox)
        end,
        OnShow = function(self)
            self.editBox:SetText("");
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self)
            local parent = self:GetParent();
            BohemkaDKP:SubtractDKPFromEditBox(parent.editBox)
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        hideOnEscape = 1
    };
    StaticPopupDialogs["ADD_GUILDPLAYERDKP"] = {
        text = "Add DKP",
        button1 = ACCEPT,
        button2 = CANCEL,
        hasEditBox = 1,
        maxLetters = 150,
        wide = true,
        editBoxWidth = 200,
        OnAccept = function(self)
            BohemkaDKP:AddDKPFromEditBox(self.editBox)
        end,
        OnShow = function(self)
            self.editBox:SetText("");
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self)
            local parent = self:GetParent();
            BohemkaDKP:AddDKPFromEditBox(parent.editBox)
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        hideOnEscape = 1
    };

    StaticPopupDialogs["SUBTRACT_GUILDPLAYERDKP_MANY"] = {
        text = "Subtract DKP",
        button1 = ACCEPT,
        button2 = CANCEL,
        hasEditBox = 1,
        maxLetters = 150,
        wide = true,
        editBoxWidth = 200,
        OnAccept = function(self)
            local dkp, reason, percent = BohemkaDKP:GetDKPFromEditBox(self.editBox)
            BohemkaDKP:SubtractDKPSelected(dkp, nil, reason, percent)
        end,
        OnShow = function(self)
            self.editBox:SetText("");
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self)
            local parent = self:GetParent()
            local dkp, reason, percent = BohemkaDKP:GetDKPFromEditBox(parent.editBox)
            BohemkaDKP:SubtractDKPSelected(dkp, nil, reason, percent)
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        hideOnEscape = 1
    };

    StaticPopupDialogs["ADD_GUILDPLAYERDKP_MANY"] = {
        text = "Add DKP",
        button1 = ACCEPT,
        button2 = CANCEL,
        hasEditBox = 1,
        maxLetters = 150,
        wide = true,
        editBoxWidth = 200,
        OnAccept = function(self)
            local dkp, reason, percent = BohemkaDKP:GetDKPFromEditBox(self.editBox)
            BohemkaDKP:AddDKPSelected(dkp, nil, reason, percent)
        end,
        OnShow = function(self)
            self.editBox:SetText("");
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self)
            local parent = self:GetParent()
            local dkp, reason, percent = BohemkaDKP:GetDKPFromEditBox(parent.editBox)
            BohemkaDKP:AddDKPSelected(dkp, nil, reason, percent)
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        hideOnEscape = 1
    };
    StaticPopupDialogs["AWARD_GUILDPLAYERDKP_RAID"] = {
        text = "Award DKP",
        button1 = ACCEPT,
        button2 = CANCEL,
        hasEditBox = 1,
        maxLetters = 150,
        wide = true,
        editBoxWidth = 200,
        OnAccept = function(self)
            BohemkaDKP:AwardDKPRaid(BohemkaDKP:GetDKPFromEditBox(self.editBox))
        end,
        OnShow = function(self)
            self.editBox:SetText("");
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self)
            local parent = self:GetParent()
            BohemkaDKP:AwardDKPRaid(BohemkaDKP:GetDKPFromEditBox(parent.editBox))
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        hideOnEscape = 1
    };
    StaticPopupDialogs["ADD_REASON_LOG"] = {
        text = "Add reason",
        button1 = ACCEPT,
        button2 = CANCEL,
        hasEditBox = 1,
        maxLetters = 150,
        wide = true,
        editBoxWidth = 250,
        OnAccept = function(self, data)
            BohemkaDKP:AddReason(data, self.editBox:GetText())
        end,
        OnShow = function(self)
            self.editBox:SetText("");
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self, data)
            local parent = self:GetParent()
            BohemkaDKP:AddReason(data, parent.editBox:GetText())
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        hideOnEscape = 1
    };
    StaticPopupDialogs["WIPE_DATA_ALL"] = {
        text = "Do you want to wipe ALL data?\n\nThis will create a backup and resets DKP to initial value.",
        button1 = YES,
        button2 = NO,
        OnAccept = function()
            BohemkaDKP:WipeDataAll()
        end,
        OnShow = function(self)
            self.editBox:SetText("");
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self)
            local parent = self:GetParent()
            BohemkaDKP:WipeDataAll()
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        showAlert = 1,
        hideOnEscape = 1
    };
end
function BohemkaDKP:UpdateBidButtonState()
    if not self.currentItem then
        return
    end
    if self.passed then
        self:EnableBidding(false)
        return
    end
    local playerName = self:GetPlayerName(true)
    local hasEnoughDKP = self.currentItem.price <= self:GetCurrentDKP(playerName)
    if self.bidInfo.name ~= playerName then
        self:EnableBidding(hasEnoughDKP)
    else
        self:EnableBidding(false)
    end
end
function BohemkaDKP:UpdatePassButtonState()
    local button = self.frames.auction.pass
    if not self.currentItem then
        return
    end
    if self:GetPlayerName(true) == self.bidInfo.name or self.passed or self.conflicts[self:GetPlayerName(true)] then
        button:Disable()
    else
        button:Enable()
    end
end
function BohemkaDKP:UpdateWinner()
    local isSelected = 0
    for i = 1, BIDDER_TABLE_SIZE do
        local frame = _G["LootMasterFrameBidder"..i]
        if frame.selected then
            isSelected = i
            break
        end
    end
    if isSelected > 0 then
        self.frames.auction.lootMasterFrame.award:Enable()
        self.currentItemWinner = BohemkaDKP.sortedHistory[isSelected]
    else
        self.frames.auction.lootMasterFrame.award:Disable()
        self.currentItemWinner = nil
    end
end
function BohemkaDKP:AddConfigEditBox(parent, relativeTo, frameName, name, value, suffix)
    local font = parent:CreateFontString("$parentText"..frameName,"ARTWORK", "GameFontNormal")
    font:SetJustifyH("LEFT")
    font:SetSize(140, 14)
    font:SetPoint(unpack(relativeTo))
    font:SetText(name)

    local editbox = CreateFrame("EditBox", "$parentEditBox"..frameName, parent, "InputBoxTemplate")
    editbox:SetAutoFocus(false)
    editbox:SetNumber(BohemkaDKPConfig[value] or 0)
    editbox:SetSize(50,20)
    editbox:SetPoint("LEFT", font, "RIGHT", 0, 0)
    editbox:SetNumeric(true)
    editbox:SetMultiLine(false)
    editbox:SetFontObject("GameFontHighlight")
    editbox:SetTextInsets(5,8,0,0)
    editbox:SetJustifyH("RIGHT")
    editbox:SetScript( "OnEscapePressed", function( self )
        self:ClearFocus()
    end )

    editbox:SetScript( "OnEnterPressed", function( self )
        self:ClearFocus()
    end )

    local font2 = parent:CreateFontString("$parentText"..frameName.."Suffix","ARTWORK", "GameFontNormal")
    font2:SetJustifyH("LEFT")
    font2:SetSize(140, 14)
    font2:SetPoint("LEFT", editbox, "RIGHT", 5, 0)
    font2:SetText(suffix or "")

    return font, editbox
end
function BohemkaDKP:CreateInterfaceConfig()
    local f = CreateFrame("Frame", "BohemkaDKPInterfaceOptionsPanel", UIParent,  BackdropTemplateMixin and "BackdropTemplate" or nil)
    f:SetPoint("CENTER")
    f:SetSize(512, 512)
    f.name = AddonName
    f:Hide()

    local debug = CreateFrame("CheckButton", "$parentDebug", f, "UICheckButtonTemplate");
    debug:SetSize(22,22)
    debug:SetPoint("TOPRIGHT", f, "TOPRIGHT", -30, -26)
    debug:SetChecked(BohemkaDKPConfig.debug)



    local font = debug:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontNormal")
    font:SetJustifyH("LEFT")
    font:SetSize(50, 14)
    font:SetPoint("RIGHT", debug, "LEFT", 0, 0)
    font:SetText("Debug")

    local importFrame = CreateFrame("Frame", "BohemkaDKPImportFrame", UIParent,  BackdropTemplateMixin and "BackdropTemplate" or nil)
    importFrame:SetPoint("CENTER")
    importFrame:SetSize(512, 512)
    importFrame:SetFrameStrata("DIALOG")
    importFrame:SetBackdrop(BACKDROP_DIALOG_32_32)
    importFrame:Hide()

    local f2 = CreateFrame("BUTTON", "$parentClose", importFrame, "UIPanelCloseButton");
    f2:SetPoint("TOPRIGHT", importFrame, "TOPRIGHT", -4, -4)

    local editbox = CreateFrame("EditBox", "$parentEditBox", importFrame)
    editbox:SetAllPoints(importFrame)
    editbox:SetWidth(importFrame:GetWidth() - 30)
    editbox:SetHeight(importFrame:GetHeight())
    editbox:SetFontObject("GameFontHighlight")
    editbox:SetAutoFocus(true)
    editbox:SetMultiLine(true)
    editbox:SetTextInsets(8,4,4,4)
    editbox:SetJustifyH("LEFT")
    editbox:SetScript( "OnEscapePressed", function( self )
        self:ClearFocus()
        importFrame:Hide()
    end )

    local Scroll = CreateFrame('ScrollFrame', '$parentEditBoxScroll', importFrame, 'UIPanelScrollFrameTemplate')
    Scroll:SetPoint('TOPLEFT', importFrame, 'TOPLEFT', 10, -30)
    Scroll:SetPoint('BOTTOMRIGHT', importFrame, 'BOTTOMRIGHT', -36, 42)
    Scroll:SetScrollChild(editbox)

    local import = CreateFrame("BUTTON", "$parentImport", importFrame, "UIPanelButtonTemplate");
    import:SetPoint("BOTTOM", 0, 15)
    import:SetWidth(120)
    import:SetText("Import")
    import:SetScript("OnClick", function()
        BohemkaDKP:Print("Importing DKP")
        local totalMembers, _, _ = GetNumGuildMembers();
        local tmp = {}
        local c = 0
        for _,v in ipairs({strsplit("\n", BohemkaDKPImportFrameEditBox:GetText())}) do
            local name, _, dkp = strsplit(",", v)
            dkp = tonumber(dkp)
            if dkp then
                tmp[strsplit("-", name)] = dkp
                c = c + 1
            end
        end
        BohemkaDKP:Print("Processing total amount of", c,"records")
        if c > 0 then
            for i = 1, totalMembers do
                fullName, rank, rankIndex, level, class, zone, note, officernote, online, isAway = GetGuildRosterInfo(i);
                local importedDKP = tmp[strsplit("-", fullName)]
                if importedDKP then
                    BohemkaDKP:SaveDKP(i, importedDKP, nil, "Imported")
                end
            end
        end
        importFrame:Hide()
    end)


    import = CreateFrame("BUTTON", "$parentImport", f, "UIPanelButtonTemplate");
    import:SetPoint("TOPLEFT", font, "BOTTOMLEFT", -50, -3)
    import:SetWidth(120)
    import:SetText("Import")
    import:SetScript("OnClick", function()
        importFrame:Show()
        BohemkaDKPImportFrameImport:Show()
        BohemkaDKPImportFrameEditBox:SetText("")
    end)

    export = CreateFrame("BUTTON", "$parentExport", f, "UIPanelButtonTemplate");
    export:SetPoint("TOP", import, "BOTTOM", 0, -2)
    export:SetWidth(120)
    export:SetText("Export")
    export:SetScript("OnClick", function()
        local totalMembers, _, _ = GetNumGuildMembers()
        local data = "name,class,dkp\n"
        local tmp = {}
        for i = 1, totalMembers do
            local fullName, _, _, _, class, _, note = GetGuildRosterInfo(i);
            table.insert(tmp, format("%s,%s,%d", fullName, class, BohemkaDKP:NoteDKPToNumber(note)))
        end
        data = data..table.concat(tmp, "\n")
        importFrame:Show()
        BohemkaDKPImportFrameEditBox:SetText(data)
        BohemkaDKPImportFrameEditBox:HighlightText()
        BohemkaDKPImportFrameImport:Hide()
    end)


    local backup = CreateFrame("BUTTON", "$parentBackup", f, "UIPanelButtonTemplate");
    backup:SetPoint("TOP", export, "BOTTOM", 0, -30)
    backup:SetWidth(120)
    backup:SetText("Backups")
    local backupDropdown = CreateFrame("Frame", "$parentDropdown", backup);
    backup:SetScript("OnClick", function()
        if UIDROPDOWNMENU_OPEN_MENU  == backupDropdown then
            BohemkaDKP:UnloadDataForBackupDropdown()
        else
            BohemkaDKP:LoadDataForBackupDropdown()
        end
        ToggleDropDownMenu(1, nil, backupDropdown, backup:GetName(), 0, 0)
    end)

    local lastBackup = f:CreateFontString("$parentLastBackup","ARTWORK", "GameFontHighlightSmall")
    lastBackup:SetJustifyH("CENTER")
    lastBackup:SetSize(120, 14)
    lastBackup:SetPoint("RIGHT", backup, "LEFT", -5, 0)
    self:UpdateLastBackupInfo()


    UIDropDownMenu_Initialize(backupDropdown, function(_, level, menuList)
        local info = UIDropDownMenu_CreateInfo()
        info.notCheckable = true
        info.keepShownOnClick = false

        if level == 1 then
            info.keepShownOnClick = false
            info.text = BohemkaDKP:colorize("Create", BohemkaDKP.COLOR.NORMAL)
            info.func = function()
                BohemkaDKP:CreateBackup()
            end
            UIDropDownMenu_AddButton(info, level)
            for _, t in ipairs(BohemkaDKP.backupDropdownData) do
                info.text = t.str
                info.menuList = "time-"..t.str
                info.hasArrow = true
                info.keepShownOnClick = true
                UIDropDownMenu_AddButton(info, level)
            end
        elseif menuList and string.find(menuList, "time")  then
            local _, dateStr = strsplit("-", menuList)
            local times
            for _, t in ipairs(BohemkaDKP.backupDropdownData) do
                if t.str == dateStr then
                    times = t.children
                    break
                end
            end
            for _, t in ipairs(times or {}) do
                info.text = t.str
                info.hasArrow = true
                info.menuList = "action-"..t.time
                info.keepShownOnClick = true
                UIDropDownMenu_AddButton(info, level)
            end
        elseif menuList and string.find(menuList, "action")  then
            local _, timeStr = strsplit("-", menuList)
            local time = tonumber(timeStr)
            info.hasArrow = false
            info.disabled = not BohemkaDKP:CanRestoreBackup()
            info.text = BohemkaDKP:colorize("Restore", info.disabled and BohemkaDKP.COLOR.DISABLE or BohemkaDKP.COLOR.GREEN )
            info.keepShownOnClick = true
            info.func = function()
                BohemkaDKP:RestoreBackup(time)
            end
            UIDropDownMenu_AddButton(info, level)

            info.text = BohemkaDKP:colorize("Delete", BohemkaDKP.COLOR.RED)
            info.hasArrow = false
            info.keepShownOnClick = false
            info.disabled = false
            info.func = function()
                BohemkaDKP:DeleteBackup(time)
                ToggleDropDownMenu(1, nil, backupDropdown, backup:GetName(), 0, 0)
            end
            UIDropDownMenu_AddButton(info, level)
        end
    end)


    local wipe = CreateFrame("BUTTON", "$parentWipe", f, "UIPanelButtonTemplate");
    wipe:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -30, 15)
    wipe:SetWidth(120)
    wipe:SetText("Wipe data")
    wipe:SetScript("OnClick", function()
        StaticPopup_Show("WIPE_DATA_ALL")
    end)
    wipe:Disable()


    local title, _ = BohemkaDKP:AddConfigEditBox(f, {"TOPLEFT", f, "TOPLEFT", 30, -30}, "MinimalBid", "Minimal Bid", "minBid", "DKP")
    title, _ = BohemkaDKP:AddConfigEditBox(f, {"TOPLEFT", title, "BOTTOMLEFT", 0, -10}, "MinItemPrice", "Minimal Item Price", "minItemPrice", "DKP")
    title, _ = BohemkaDKP:AddConfigEditBox(f, {"TOPLEFT", title, "BOTTOMLEFT", 0, -10}, "AuctionCountdown", "Auction Countdown", "timerMax", "second(s)")
    dkp, _ = BohemkaDKP:AddConfigEditBox(f, {"TOPLEFT", title, "BOTTOMLEFT", 0, -10}, "StartingDKP", "Initial DKP", "startingDKP")
    title, _ = BohemkaDKP:AddConfigEditBox(f, {"LEFT", dkp, "RIGHT", 158, 0}, "AutoBackup", "Automatic backup", "autoBackup", "hour(s)")
    title, _ = BohemkaDKP:AddConfigEditBox(f, {"TOPLEFT", dkp, "BOTTOMLEFT", 0, -10}, "BidCooldown", "Bid Cooldown", "bidCooldown", "second(s)")



    local auctionStartKeyBind = CreateFrame("Frame", "$parentAuctionKeyBind", f, "UIDropDownMenuTemplate")
    auctionStartKeyBind:SetPoint("TOPLEFT", title, "BOTTOMLEFT", -17, -30)
    auctionStartKeyBind.value = BohemkaDKPConfig.startAuctionModifier

    local initMenu = function()
        local selectedValue = UIDropDownMenu_GetSelectedValue(auctionStartKeyBind);
        local info = UIDropDownMenu_CreateInfo();

        for _, key in ipairs({"ALT", "SHIFT", "SHIFT+ALT"}) do
            info.text = key;
            info.func = function(self)
                auctionStartKeyBind:SetValue(self.value)
            end;
            info.value = key
            if ( info.value == selectedValue ) then
                info.checked = 1;
            else
                info.checked = nil;
            end
            UIDropDownMenu_AddButton(info);
        end

    end

    UIDropDownMenu_Initialize(auctionStartKeyBind, initMenu);
    UIDropDownMenu_SetSelectedValue(auctionStartKeyBind, auctionStartKeyBind.value);

    auctionStartKeyBind.SetValue = function (self, value)
        self.value = value;
        BohemkaDKPConfig.startAuctionModifier = value
        UIDropDownMenu_SetSelectedValue(self, value);
    end
    auctionStartKeyBind.GetValue = function (self)
        return UIDropDownMenu_GetSelectedValue(self);
    end
    auctionStartKeyBind.RefreshValue = function (self)
        UIDropDownMenu_Initialize(self, initMenu)
        UIDropDownMenu_SetSelectedValue(self, self.value);
    end


    font = auctionStartKeyBind:CreateFontString("$parentText","ARTWORK", "GameFontNormal")
    font:SetJustifyH("LEFT")
    -- font:SetSize(150, 14)
    font:SetPoint("BOTTOMLEFT", auctionStartKeyBind, "TOPLEFT", 16, 3)
    font:SetText("Auction Start Modifier")
    local charNameChatButton = CreateFrame("CheckButton", "$parentShowCharNamesInChat", f, "UICheckButtonTemplate");
    charNameChatButton:SetSize(22,22)
    charNameChatButton:SetPoint("LEFT", f, "RIGHT", -53, 115)
    charNameChatButton:SetChecked(BohemkaDKPConfig.showCharNameInChat)

    font = charNameChatButton:CreateFontString("$parentText","ARTWORK", "GameFontNormal")
    font:SetJustifyH("LEFT")
    font:SetSize(200, 14)
    font:SetPoint("RIGHT", charNameChatButton, "LEFT", 0, 0)
    font:SetText("Append main name in the chat")

    local l = f:CreateLine()
    l:SetColorTexture(0.3,0.3,0.3)
    l:SetStartPoint("TOPLEFT", f, 30, -220)
    l:SetEndPoint("TOPRIGHT", f, -30, -220)
    l:SetThickness(1)

    font = f:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontNormal")
    font:SetJustifyH("CENTER")
    font:SetSize(256, 14)
    font:SetPoint("TOPLEFT", l, "BOTTOMLEFT", 0, -10)
    font:SetText("Custom Minimal Item Price")

    local editBoxHeight = 265
    editboxBg = CreateFrame("Frame", "$parentEditBoxItemPrice", f, "TooltipBackdropTemplate")
    editboxBg:SetSize(font:GetWidth(), editBoxHeight)
    editboxBg:SetPoint("TOP", font, "BOTTOM", 0, -5)

    local itemPriceConfig = self:TableToConfigText(BohemkaDKPConfig.itemPrices)
    editbox = CreateFrame("EditBox", "$parentItemPrice", editboxBg)
    editbox:SetAllPoints(editboxBg)
    editbox:SetWidth(editboxBg:GetWidth() - 30)
    editbox:SetHeight(editboxBg:GetHeight())
    editbox:SetFontObject("GameFontHighlight")
    editbox:SetAutoFocus(false)
    editbox:SetMultiLine(true)
    editbox:SetTextInsets(8,8,8,8)
    editbox:SetText(itemPriceConfig)
    editbox:SetJustifyH("LEFT")
    editbox:SetScript( "OnEscapePressed", function( self )
        self:ClearFocus()
    end )

    Scroll = CreateFrame('ScrollFrame', '$parentEditBoxItemPriceScroll', f, 'UIPanelScrollFrameTemplate')
    Scroll:SetPoint('TOPLEFT', editboxBg, 'TOPLEFT', 8, -4)
    Scroll:SetPoint('BOTTOMRIGHT', editboxBg, 'BOTTOMRIGHT', -26, 3)
    Scroll:SetScrollChild(editbox)

    font = f:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontNormalSmall")
    font:SetJustifyH("LEFT")
    font:SetWidth(editbox:GetWidth())
    font:SetPoint("TOPLEFT", editboxBg, "BOTTOMLEFT", 10, -3)
    font:SetText("Example:")

    local font2 = f:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontHighlightSmall")
    font2:SetJustifyH("LEFT")
    font2:SetSize(editbox:GetWidth(), 40)
    font2:SetPoint("TOPLEFT", font, "BOTTOMLEFT", 0, 5)
    font2:SetText("Item Name=10\nItem Name2=30")

    font = f:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontNormal")
    font:SetJustifyH("CENTER")
    font:SetSize(256, 14)
    font:SetPoint("TOPRIGHT", l, "BOTTOMRIGHT", 0, -10)
    font:SetText("Boss Reward")


    local editboxBg = CreateFrame("Frame", "$parentEditBoxBossRewards", f, "TooltipBackdropTemplate")
    editboxBg:SetSize(font:GetWidth(), editBoxHeight)
    editboxBg:SetPoint("TOP", font, "BOTTOM", 0, -5)

    editbox = CreateFrame("EditBox", "$parentBossRewards", editboxBg)
    editbox:SetAllPoints(editboxBg)
    editbox:SetWidth(editboxBg:GetWidth() - 30)
    editbox:SetHeight(editboxBg:GetHeight())
    editbox:SetFontObject("GameFontHighlight")
    editbox:SetAutoFocus(false)
    editbox:SetMultiLine(true)
    editbox:SetText(self:TableToConfigText(BohemkaDKPConfig.bossRewards))
    editbox:SetTextInsets(8,8,8,8)
    editbox:SetJustifyH("LEFT")
    editbox:SetJustifyV("TOP")
    editbox:SetScript( "OnEscapePressed", function( self )
        self:ClearFocus()
    end )



    Scroll = CreateFrame('ScrollFrame', '$parentEditBoxBossRewardsScroll', f, 'UIPanelScrollFrameTemplate')
    Scroll:SetPoint('TOPLEFT', editboxBg, 'TOPLEFT', 8, -4)
    Scroll:SetPoint('BOTTOMRIGHT', editboxBg, 'BOTTOMRIGHT', -26, 3)
    Scroll:SetScrollChild(editbox)

    font = f:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontNormalSmall")
    font:SetJustifyH("LEFT")
    font:SetWidth(editboxBg:GetWidth())
    font:SetPoint("TOPLEFT", editboxBg, "BOTTOMLEFT", 10, -3)
    font:SetText("Example:")

    font2 = f:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontHighlightSmall")
    font2:SetJustifyH("LEFT")
    font2:SetSize(editbox:GetWidth(), 40)
    font2:SetPoint("TOPLEFT", font, "BOTTOMLEFT", 0, 5)
    font2:SetText("Boss 1=10\nBoss 2=30")

    BohemkaDKPInterfaceOptionsPanel.okay = function()
        BohemkaDKPConfig.itemPrices = BohemkaDKP:ConfigTextToTable(BohemkaDKPInterfaceOptionsPanelEditBoxItemPriceItemPrice:GetText())
        BohemkaDKPConfig.bossRewards = BohemkaDKP:ConfigTextToTable(BohemkaDKPInterfaceOptionsPanelEditBoxBossRewardsBossRewards:GetText())
        BohemkaDKPConfig.minBid = BohemkaDKPInterfaceOptionsPanelEditBoxMinimalBid:GetNumber()
        BohemkaDKPConfig.minItemPrice = BohemkaDKPInterfaceOptionsPanelEditBoxMinItemPrice:GetNumber()
        BohemkaDKPConfig.auctionCountdown= BohemkaDKPInterfaceOptionsPanelEditBoxAuctionCountdown:GetNumber()
        BohemkaDKPConfig.startingDKP = BohemkaDKPInterfaceOptionsPanelEditBoxStartingDKP:GetNumber()
        BohemkaDKPConfig.bidCooldown = BohemkaDKPInterfaceOptionsPanelEditBoxBidCooldown:GetNumber()
        BohemkaDKPConfig.autoBackup = BohemkaDKPInterfaceOptionsPanelEditBoxAutoBackup:GetNumber()
        BohemkaDKPConfig.debug = BohemkaDKPInterfaceOptionsPanelDebug:GetChecked()
        BohemkaDKPConfig.showCharNameInChat = BohemkaDKPInterfaceOptionsPanelShowCharNamesInChat:GetChecked()
        BohemkaDKPConfig.startAuctionModifier = UIDropDownMenu_GetSelectedValue(BohemkaDKPInterfaceOptionsPanelAuctionKeyBind)
    end
    BohemkaDKPInterfaceOptionsPanel.cancel = function()
        BohemkaDKPInterfaceOptionsPanelEditBoxBossRewardsBossRewards:SetText(BohemkaDKP:TableToConfigText(BohemkaDKPConfig.bossRewards))
        BohemkaDKPInterfaceOptionsPanelEditBoxItemPriceItemPrice:SetText(BohemkaDKP:TableToConfigText(BohemkaDKPConfig.itemPrices))
        BohemkaDKPInterfaceOptionsPanelEditBoxMinimalBid:SetNumber(BohemkaDKPConfig.minBid)
        BohemkaDKPInterfaceOptionsPanelEditBoxAuctionCountdown:SetNumber(BohemkaDKPConfig.auctionCountdown)
        BohemkaDKPInterfaceOptionsPanelEditBoxStartingDKP:SetNumber(BohemkaDKPConfig.startingDKP)
        BohemkaDKPInterfaceOptionsPanelEditBoxBidCooldown:SetNumber(BohemkaDKPConfig.bidCooldown)
        BohemkaDKPInterfaceOptionsPanelEditBoxAutoBackup:SetNumber(BohemkaDKPConfig.autoBackup)
        BohemkaDKPInterfaceOptionsPanelDebug:SetChecked(BohemkaDKPConfig.debug)
        BohemkaDKPInterfaceOptionsPanelDebug:SetChecked(BohemkaDKPConfig.startAuctionModifier)
        BohemkaDKPInterfaceOptionsPanelShowCharNamesInChat:SetChecked(BohemkaDKPConfig.showCharNameInChat)
        UIDropDownMenu_SetSelectedValue(BohemkaDKPInterfaceOptionsPanelAuctionKeyBind, BohemkaDKPConfig.startAuctionModifier);

    end

    InterfaceOptions_AddCategory(f)
end
function BohemkaDKP:LoadDataForBackupDropdown()
    local tmp = {}
    for time, _ in pairs(CurrentDKPLog.backup) do
        table.insert(tmp, time)
    end
    table.sort(tmp, function(a,b) return a > b  end)
    local split = {}
    for _, time in ipairs(tmp) do
        local dateStr = date('%Y/%m/%d', time)
        if not split[dateStr] then
            split[dateStr] = {}
        end
        split[dateStr] = time
    end
    local dates = {}
    for dateStr, time in pairs(split) do
        dates[#dates + 1] = { str = dateStr, time = time, children = {}}
    end
    table.sort(dates, function(a,b) return a.time > b.time  end)
    for _, time in ipairs(tmp) do
        local timeStr = date('%H:%M', time)
        local dateStr = date('%Y/%m/%d', time)
        for _, t in ipairs(dates) do
            if t.str == dateStr then
                t.children[#t.children + 1] = {time = time, str = timeStr}
            end
        end
    end
    self.backupDropdownData = dates
end
function BohemkaDKP:UnloadDataForBackupDropdown()
    self.backupDropdownData = nil
end
function BohemkaDKP:TableToConfigText(t)
    local str = {}
    for k, v in pairs(t) do
        table.insert(str, k.."="..v)
    end
    return table.concat(str, "\n")
end
function BohemkaDKP:ConfigTextToTable(txt)
    local t = {}
    for _, v in ipairs({strsplit("\n", txt)}) do
        local k, v2 = strsplit("=", v)
        t[k] = tonumber(v2) or v2
    end
    return t
end
function BohemkaDKP:RenderProfessions(frameName, playerName, professions, showSkill)
    for i = 1, PROFESSION_AMOUNT do
        local detailFrame = _G[format(frameName, i)]
        self:HideProfessionFrame(detailFrame)
    end
    for i = 1, #professions do
        local detailFrame = _G[format(frameName, i)]
        local name = professions[i].name
        if BohemkaDKP.PROFESSIONS[name] then
            local tooltip = name
            local isSecondary = BohemkaDKP.SECONDARY_PROFESSIONS[name]
            if isSecondary then
                detailFrame = _G[format(frameName, BohemkaDKP.PROFESSIONS[name])]
            end
            if detailFrame then
                if showSkill then
                    detailFrame.parent.font:SetText(professions[i].rank)
                elseif professions[i].rank then
                    tooltip = tooltip.." - "..professions[i].rank
                end
                detailFrame.parent.tooltip = tooltip
                detailFrame.parent.playerName = playerName
                detailFrame.parent.profession = professions[i]
                local alpha = 0.5
                local craftHistory = self:GetPlayerCraftHistory(playerName)
                if craftHistory and craftHistory[name] then
                    alpha = 1
                end
                detailFrame:SetAlpha(alpha)
                detailFrame:SetTexture(self:GetProfessionIcon(professions[i]))
                detailFrame.parent:Show()
            end
        end
    end
end
function BohemkaDKP:HideProfessionFrame(frame)
    frame.parent.tooltip = nil
    frame.parent.font:SetText("")
    frame:SetTexture(nil)
    frame.parent:Hide()
end
function BohemkaDKP:GetFriendsFrameWidth()
    local width = FRIENDS_FRAME_WIDTH
    if not BohemkaDKPConfig.showProfessions then
        width = width - GUILD_FRAME_COLUMN_WIDTH_PROFESSIONS
    end
    if not BohemkaDKPConfig.showDKP then
        width = width - GUILD_FRAME_COLUMN_WIDTH_DKP
    end
    return width
end
function BohemkaDKP:UpdateLastBackupInfo()
    BohemkaDKPInterfaceOptionsPanelLastBackup:SetText(CurrentDKPLog.lastBackup and date('%Y/%m/%d %H:%M', CurrentDKPLog.lastBackup) or "-")
end
function BohemkaDKP:CreateBenchFrame()
    --local benchSize = BohemkaDKPConfig.benchSize
    --local slotHeight = 16
    --local f = CreateFrame("Frame", "$parentBench", RaidFrame, BackdropTemplateMixin and "BackdropTemplate" or nil)
    --f:SetSize(170, benchSize * slotHeight + 39)
    --f:SetPoint("TOPLEFT", RaidFrame, "TOPRIGHT", 0, -38)
    --f:SetBackdrop(BACKDROP_TOOLTIP_0_16_5555)
    --
    --local marble = f:CreateTexture(nil, "BACKGROUND")
    --marble:SetPoint("TOPLEFT", 4, -4)
    --marble:SetPoint("BOTTOMRIGHT", -4, 4)
    --marble:SetTexture("Interface\\FrameGeneral\\UI-Background-Rock", true, true)
    --
    --local font = f:CreateFontString("$parentText","ARTWORK", "GameFontNormalSmall")
    --font:SetText("Bench")
    --font:SetPoint("TOP", f, "TOP", 0, -7)
    --
    --local prevBtn
    --local prevBg
    --local iconSize = 11
    --for i = 1, benchSize do
    --    local btn = CreateFrame("Button", "$parentSlot"..i, f, "RaidGroupSlotTemplate")
    --    if not prevBtn then
    --        btn:SetPoint("TOP", font, "BOTTOM", 0, -6)
    --    else
    --        if i % 5 == 1 then
    --            btn:SetPoint("TOP", prevBtn, "BOTTOM", 0, -20)
    --        else
    --            btn:SetPoint("TOP", prevBtn, "BOTTOM", 0, -1)
    --        end
    --    end
    --
    --    local name = btn:CreateFontString("$parentName","ARTWORK", "GameFontNormalSmall")
    --    name:SetPoint("LEFT", 20, 0)
    --    name:SetSize(105, 12)
    --    name:SetJustifyH("LEFT")
    --
    --    local specContainer = CreateFrame("Frame", "$parentSpec", btn)
    --    specContainer:SetSize(iconSize,iconSize)
    --    specContainer:SetPoint("RIGHT", btn, "RIGHT", -1, 0.5)
    --    local spec = specContainer:CreateTexture("$parentIcon", "ARTWORK")
    --    spec:SetAllPoints(specContainer)
    --    specContainer:SetScript("OnEnter", function(self)
    --        if self.tooltip then
    --            GameTooltip:SetOwner(self, "ANCHOR_TOP");
    --            GameTooltip:SetText(self.tooltip);
    --            GameTooltip:Show();
    --        end
    --    end)
    --    specContainer:SetScript("OnLeave", function()
    --        GameTooltip:Hide();
    --    end)
    --
    --    local class = btn:CreateTexture("$parentClass", "ARTWORK")
    --    class:SetSize(iconSize,iconSize)
    --    class:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes")
    --    class:SetPoint("RIGHT", specContainer, "RIGHT", -iconSize - 1, 0)
    --
    --    if i % 5 == 0 then
    --        local slotBg = f:CreateTexture(nil, "ARTWORK")
    --        slotBg:SetSize(162, 80)
    --        if not prevBg then
    --            slotBg:SetPoint("TOPLEFT", 4, -20)
    --        else
    --            slotBg:SetPoint("TOPLEFT", prevBg, "BOTTOMLEFT", 0, -14)
    --        end
    --        slotBg:SetTexture("Interface\\RaidFrame\\UI-RaidFrame-GroupOutline")
    --        slotBg:SetTexCoord(0, 0.6640625, 0, 0.625)
    --        prevBg = slotBg
    --    end
    --    prevBtn = btn
    --end
    --self.benchExists = true
end
function BohemkaDKP:RenderBench()
    if not self.benchExists then
        return
    end
    local tmp = {}
    for name, _ in pairs(BohemkaDKPConfig.bench) do
        tmp[#tmp + 1] = name
    end

    for i=1, BohemkaDKPConfig.benchSize do
        local buttonName = _G["RaidFrameBenchSlot"..i.."Name"];
        local buttonClass = _G["RaidFrameBenchSlot"..i.."Class"];
        local buttonSpecIcon = _G["RaidFrameBenchSlot"..i.."SpecIcon"];
        local buttonSpec = _G["RaidFrameBenchSlot"..i.."Spec"];
        local btn = _G["RaidFrameBenchSlot"..i];

        if tmp[i] then
            btn:SetNormalTexture("Interface\\RaidFrame\\UI-RaidFrame-GroupButton")
            btn:GetNormalTexture():SetTexCoord(0, 0.640625, 0, 0.4375)
            btn:SetHighlightTexture("Interface\\RaidFrame\\UI-RaidFrame-GroupButton")
            btn:GetHighlightTexture():SetTexCoord(0, 0.640625, 0.5, 0.9375)
            btn:GetHighlightTexture():SetBlendMode("ADD")
            buttonName:SetText(self:AddClassColorToName(tmp[i]))
            local _, spec, amounts = self:GetPlayerTalents(tmp[i])
            if spec then
                buttonSpecIcon:SetTexture(spec.icon)
                buttonSpec.tooltip = table.concat(amounts, "/")
            end
            if self.guildRoster[tmp[i]] then
                local class = select(11, unpack(self.guildRoster[tmp[i]]))
                local coords = CLASS_ICON_TCOORDS[class]
                buttonClass:SetTexCoord(coords[1], coords[2], coords[3], coords[4])
                buttonClass:Show()
            end
        else
            buttonName:SetText("")
            btn:SetNormalTexture(nil)
            -- btn:SetHighlightTexture(nil)
            buttonSpecIcon:SetTexture(nil)
            buttonSpec.tooltip = nil
            buttonClass:Hide()
        end
    end
end
function BohemkaDKP:CreateGuildCraftFrame()
    local f = CreateFrame("Frame", "GuildCraftFrame", UIParent, BackdropTemplateMixin and "BackdropTemplate" or nil)
    f:SetSize(384, 512)
    f:SetPoint("TOPLEFT", GuildFrame, "TOPRIGHT", 0, 14)
    f:SetHitRectInsets(0, 34, 0, 75)
    f:SetFrameStrata("HIGH")
    f:SetMovable(true)
    f:EnableMouse(true)
    f:RegisterForDrag("LeftButton")
    f:SetScript("OnDragStart", f.StartMoving)
    f:SetScript("OnDragStop", f.StopMovingOrSizing)
    f:Hide()
    f.mode = "single"
    f:SetScript("OnHide", function (self)
        self.profession = nil
        self.playerName = nil
        BohemkaDKP:SelectCraftListButton()
        BohemkaDKP:UpdateCraftList()

    end)
    f.attachedX = -30
    f.detachedY = 14

    --local bg = f:CreateTexture(nil, "ARTWORK")
    --bg:SetPoint("TOPLEFT", 185 , -412)
    --bg:SetSize(155, 18)
    --bg:SetTexture("Interface\\FrameGeneral\\UI-Background-Rock")
    ----local ULx,ULy,LLx,LLy,URx,URy,LRx,LRy = bg:GetTexCoord()
    --bg:SetTexCoord(0, 0.5, 0, 0.1)
    ----local w = bg:GetWidth();
    ----bg:SetWidth(w * 0.5)

    local clear = CreateFrame("BUTTON", "$parentClear", f, "UIPanelButtonTemplate");
    clear:SetPoint("TOPLEFT", 183 , -409)
    clear:SetText("Clear")
    clear:SetScript("OnClick", function()
        GuildCraftMemberSearchValue:SetSearchValue()
        GuildCraftMemberSearchValue:ClearFocus()
    end)
    clear:SetWidth(77)

    local closeBtn = CreateFrame("BUTTON", "$parentCloseButton", f, "UIPanelButtonTemplate");
    closeBtn:SetPoint("LEFT", clear, "RIGHT", 3, 0)
    closeBtn:SetText("Close")
    closeBtn:SetScript("OnClick", function()
        f:Hide()
    end)
    closeBtn:SetWidth(77)

    local close = CreateFrame("BUTTON", "$parentClose", f, "UIPanelCloseButton");
    close:SetPoint("TOPRIGHT", f, "TOPRIGHT", -30, -8)

    local portrait = f:CreateTexture("$parentPortrait", "BACKGROUND")
    portrait:SetSize(60,60)
    portrait:SetPoint("TOPLEFT", 7, -6)

    local border1 = f:CreateTexture("$parentBorderTopLeft", "BORDER")
    border1:SetSize(256,256)
    border1:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-TopLeft")
    border1:SetPoint("TOPLEFT")

    local border2 = f:CreateTexture("$parentBorderTopRight", "BORDER")
    border2:SetSize(128,256)
    border2:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-TopRight")
    border2:SetPoint("TOPRIGHT")

    local border3 = f:CreateTexture("$parentBorderBotLeft", "BORDER")
    border3:SetSize(256,256)
    border3:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-BotLeft")
    border3:SetPoint("BOTTOMLEFT")

    local border4 = f:CreateTexture("$parentBorderBotRight", "BORDER")
    border4:SetSize(128,256)
    border4:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-BotRight")
    border4:SetPoint("BOTTOMRIGHT")

    local font = f:CreateFontString("$parentTitle","BORDER", "GameFontNormal")
    font:SetText("Profession")
    font:SetPoint("TOP", 0, -18)



    local skillBorder1 = f:CreateTexture("$parentSkillBorderLeft", "ARTWORK")
    skillBorder1:SetSize(256,8)
    skillBorder1:SetTexture("Interface\\TradeSkillFrame\\UI-TradeSkill-SkillBorder")
    skillBorder1:SetPoint("TOPLEFT", 63, -50)
    skillBorder1:SetTexCoord(0, 1.0, 0, 0.25)

    local skillBorder2 = f:CreateTexture("$parentSkillBorder", "ARTWORK")
    skillBorder2:SetSize(28,8)
    skillBorder2:SetTexture("Interface\\TradeSkillFrame\\UI-TradeSkill-SkillBorder")
    skillBorder2:SetPoint("LEFT", GuildCraftFrameSkillBorderLeft, "RIGHT", 0, 0)
    skillBorder2:SetTexCoord(0, 0.109375, 0.25, 0.5)


    local skillBorder3 = f:CreateTexture("$parentHorizontalSkillBorderLeft", "ARTWORK")
    skillBorder3:SetSize(256,16)
    skillBorder3:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-HorizontalBar")
    skillBorder3:SetPoint("TOPLEFT", 15, -221)
    skillBorder3:SetTexCoord(0, 1.0, 0, 0.25)

    local skillBorder4 = f:CreateTexture("$parentHorizontalSkillBorder", "ARTWORK")
    skillBorder4:SetSize(75,16)
    skillBorder4:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-HorizontalBar")
    skillBorder4:SetPoint("LEFT", GuildCraftFrameHorizontalSkillBorderLeft, "RIGHT", 0, 0)
    skillBorder4:SetTexCoord(0, 0.29296875, 0.25, 0.5)

    local skillRankFrame = CreateFrame("StatusBar", "$parentSkillRankFrame", f)
    skillRankFrame:SetMinMaxValues(0, 1)
    skillRankFrame:SetValue(0)
    skillRankFrame:SetSize(268, 15)
    skillRankFrame:SetPoint("TOPLEFT", 73, -37)
    skillRankFrame:SetStatusBarTexture("Interface\\PaperDollInfoFrame\\UI-Character-Skills-Bar")
    skillRankFrame:SetStatusBarColor(0.25, 0.25, 0.75)

    local skillName = skillRankFrame:CreateFontString("$parentSkillName","ARTWORK", "GameFontNormalSmall")
    skillName:SetText("Profession")
    skillName:SetPoint("LEFT", 6, 1)

    local skillRank = skillRankFrame:CreateFontString("$parentSkillRank","ARTWORK", "GameFontHighlightSmall")
    skillRank:SetText("0/0")
    skillRank:SetSize(128, 0)
    skillRank:SetPoint("LEFT", "$parentSkillName", "RIGHT", 13, 0)
    skillRank:SetJustifyH("LEFT")

    local skillRankBg = skillRankFrame:CreateTexture("$parentBackground", "BACKGROUND")
    skillRankBg:SetColorTexture(1, 1, 1, 0.2)

    local skillRankBorder = CreateFrame("Button", "$parentBorder", skillRankFrame)
    skillRankBorder:SetSize(281, 32)
    skillRankBorder:SetPoint("LEFT", -5, 0)
    skillRankBorder:SetNormalTexture("Interface\\PaperDollInfoFrame\\UI-Character-Skills-BarBorder")

    local highlightFrame = CreateFrame("Frame", "$parentHighlight", f, BackdropTemplateMixin and "BackdropTemplate" or nil)
    highlightFrame:SetSize(297, 16)
    highlightFrame:SetPoint("TOPLEFT", 0, -30)
    highlightFrame:SetFrameStrata("HIGH")
    highlightFrame:Hide()

    local tx = highlightFrame:CreateTexture("$parentTex", "ARTWORK")
    tx:SetTexture("Interface\\Buttons\\UI-Listbox-Highlight2")
    tx:SetAllPoints(true)

    local prevSkillFrame
    for i=1, CRAFTS_DISPLAYED do
        local skillFrame = CreateFrame("Button", "$parentSkillFrame"..i, f, "SecureHandlerClickTemplate")
        local skillFrameText = skillFrame:CreateFontString("$parentText","ARTWORK", "GameFontNormal")
        skillFrameText:SetText("Recipe")
        skillFrameText:SetFont("Fonts\\FRIZQT__.TTF", 11)
        skillFrameText:SetSize(290, 11)
        skillFrameText:SetPoint("LEFT", 8, 0)
        skillFrameText:SetJustifyH("LEFT")
        skillFrame:SetSize(CRAFT_SKILL_BUTTON_WIDTH, 16)
        skillFrame:SetFontString(skillFrameText)
        skillFrame:SetNormalFontObject("GameFontNormal")
        skillFrame:SetHighlightFontObject("GameFontHighlight")
        skillFrame:SetDisabledFontObject("GameFontDisable")
        skillFrame:Show()
        if not prevSkillFrame then
            skillFrame:SetPoint("TOPLEFT", 22, -96)
        else
            skillFrame:SetPoint("TOPLEFT", prevSkillFrame, "BOTTOMLEFT", 0, 0)
        end
        skillFrame:SetScript("OnClick", function(self)
            if self.craft then
                BohemkaDKP:SelectCraftButton(self)
            end
        end)

        local minusBtn = skillFrame:CreateTexture("$parentNormal", "ARTWORK")
        minusBtn:SetTexture("Interface\\Buttons\\UI-MinusButton-UP")
        minusBtn:SetPoint("LEFT", 3, 0)
        minusBtn:SetSize(16,16)
        minusBtn:SetAlpha(0)

        local disabledBtn = skillFrame:CreateTexture("$parentDisabled", "ARTWORK")
        disabledBtn:SetTexture("Interface\\Buttons\\UI-PlusButton-Disabled")
        disabledBtn:SetPoint("LEFT", 3, 0)
        disabledBtn:SetSize(16,16)
        disabledBtn:SetAlpha(0)

        skillFrame:SetNormalTexture(minusBtn)
        skillFrame:SetDisabledTexture(disabledBtn)
        prevSkillFrame = skillFrame
    end

    local scroll = CreateFrame('ScrollFrame', '$parentScrollFrame', f, 'ClassTrainerListScrollFrameTemplate')
    scroll:SetSize(296, 130)
    scroll:SetPoint('TOPRIGHT', f, 'TOPRIGHT', -67, -96)
    scroll:SetScript("OnVerticalScroll", function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, function()
            BohemkaDKP:UpdateCrafts()
        end)
    end)
    local scrollDetail = CreateFrame('ScrollFrame', '$parentScrollDetailFrame', f, 'ClassTrainerDetailScrollFrameTemplate')
    scrollDetail:SetSize(297, 176)
    scrollDetail:SetPoint('TOPLEFT', 20, -234)

    local scrollDetailChild = CreateFrame('Frame', '$parentChildFrame', scrollDetail)
    scrollDetailChild:SetSize(297, 150)

    font = scrollDetailChild:CreateFontString("$parentSkillName","BACKGROUND", "GameFontNormal")
    font:SetSize(244, 0)
    font:SetText("Skill Name")
    font:SetJustifyH("LEFT")
    font:SetPoint("TOPLEFT", 50, -5)

    font = scrollDetailChild:CreateFontString("$parentCooldown", "BACKGROUND", "GameFontRedSmall")
    font:SetText("COOLDOWN")
    font:SetPoint("TOPLEFT", "$parentSkillName", "BOTTOMLEFT", 0, 0)

    local headerLeft = scrollDetailChild:CreateTexture("$parentHeaderLeft", "ARTWORK")
    headerLeft:SetSize(256,64)
    headerLeft:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-DetailHeaderLeft")
    headerLeft:SetPoint("TOPLEFT", 0, 3)

    local headerRight = scrollDetailChild:CreateTexture("$parentHeaderRight", "ARTWORK")
    headerRight:SetSize(64,64)
    headerRight:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-DetailHeaderRight")
    headerRight:SetPoint("TOPLEFT", headerLeft, "TOPRIGHT", 0, 0)

    font = scrollDetailChild:CreateFontString("$parentDescription", "BACKGROUND", "GameFontHighlightSmall")
    font:SetSize(290, 0)
    font:SetJustifyH("LEFT")
    font:SetPoint("TOPLEFT", 5, -50)

    font = scrollDetailChild:CreateFontString("$parentReagentLabel", "BACKGROUND", "GameFontNormalSmall")
    font:SetText(SPELL_REAGENTS)
    font:SetPoint("TOPLEFT", 8, -47)



    local skillIcon = CreateFrame("Button", "$parentSkillIcon", scrollDetailChild)
    skillIcon:SetSize(37,37)
    skillIcon:SetPoint("TOPLEFT", 8, -3)

    local skillIconTexture = skillIcon:CreateTexture("$parentTexture", "ARTWORK")
    skillIconTexture:SetAllPoints(true)


    local skillIconText = skillIcon:CreateFontString("$parentCount", "ARTWORK", "NumberFontNormal")
    skillIconText:SetJustifyH("RIGHT")
    skillIconText:SetPoint("BOTTOMRIGHT", -5, 2)

    skillIcon:SetScript("OnClick", function(self)
        HandleModifiedItemClick(self.itemLink)
    end)
    skillIcon:SetScript("OnEnter", function(self)
        if self.itemLink then
            GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
            GameTooltip:SetHyperlink(self.itemLink)
            CursorUpdate(self)
        end
    end)
    skillIcon:SetScript("OnLeave", function(self)
        GameTooltip:Hide()
        ResetCursor()
    end)

    local reagents = {}
    for i=1, 8 do
        local skillReagent = CreateFrame("Button", "$parentSkillReagent"..i, scrollDetailChild, "QuestItemTemplate")
        skillReagent.id = i
        skillReagent:SetScript("OnEnter", function(self)
            if self.itemLink then
                GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
                GameTooltip:SetHyperlink(self.itemLink)
                CursorUpdate(self)
            end
        end)
        skillReagent:SetScript("OnLeave", function(self)
            GameTooltip:Hide()
            ResetCursor()
        end)
        skillReagent:SetScript("OnClick", function(self)
            HandleModifiedItemClick(self.itemLink)
        end)

        _G["GuildCraftFrameScrollDetailFrameChildFrameSkillReagent"..i.."Name"]:SetText("Test")
        table.insert(reagents, skillReagent)
    end
    reagents[1]:SetPoint("TOPLEFT", "$parentReagentLabel", "BOTTOMLEFT", -2, -3)
    reagents[2]:SetPoint("LEFT", reagents[1], "RIGHT", 0, 0)
    reagents[3]:SetPoint("TOPLEFT", reagents[1], "BOTTOMLEFT", 0, -2)
    reagents[4]:SetPoint("LEFT", reagents[3], "RIGHT", 0, 0)
    reagents[5]:SetPoint("TOPLEFT", reagents[3], "BOTTOMLEFT", 0, -2)
    reagents[6]:SetPoint("LEFT", reagents[5], "RIGHT", 0, 0)
    reagents[7]:SetPoint("TOPLEFT", reagents[6], "BOTTOMLEFT", 0, -2)
    reagents[8]:SetPoint("LEFT", reagents[7], "RIGHT", 0, 0)

    scrollDetail:SetScrollChild(scrollDetailChild)

    local e = CreateFrame("EditBox", "GuildCraftMemberSearchValue", f)
    e:SetWidth(150)
    e:SetHeight(33)
    e:SetPoint("TOPLEFT", scrollDetail, "BOTTOMLEFT", 8, 7)
    e:SetFont("Fonts\\FRIZQT__.TTF", 11)
    e:SetTextInsets(0,0,0,0)
    e:SetMultiLine(false)
    e:SetAutoFocus(false)
    e:SetJustifyH("LEFT")
    e.blockSearch = true
    e:SetScript( "OnEscapePressed", function( )
        e:ClearFocus()
    end )
    local searchText = self:colorize("Search", self.COLOR.GRAY)
    e:SetText(searchText)
    e:SetScript("OnEnterPressed", function(self)
        self:ClearFocus()
    end)
    e:SetScript("OnTextChanged", function(self)
        if self.blockSearch then
            return
        end
        BohemkaDKP:RenderFilteredCrafts(self:GetText(), GuildCraftFrame.profession, GuildCraftFrame.playerName)
    end)
    e:SetScript("OnEditFocusGained", function(self)
        if self:GetText() == searchText then
            self:SetText("")
            self.blockSearch = false
        end
    end)
    e.SetSearchValue = function (self, value)
        if not value or value == "" then
            self:SetText(searchText)
            self.blockSearch = true
            BohemkaDKP:RenderCrafts(GuildCraftFrame.playerName, GuildCraftFrame.profession, Crafts[GuildCraftFrame.playerName][GuildCraftFrame.profession.name])
        else
            self:SetText(value)
            self.blockSearch = false
            BohemkaDKP:RenderFilteredCrafts(self:GetText(), GuildCraftFrame.profession, GuildCraftFrame.playerName)
        end
    end
    e:SetScript("OnEditFocusLost", function(self)
        self:SetSearchValue(self:GetText())
    end)

    local playerReagents = CreateFrame("CheckButton", "$parentPlayerReagents", f, "UICheckButtonTemplate")
    playerReagents:SetPoint("TOPLEFT", f, 150, -65)
    playerReagents:SetSize(20, 20)
    playerReagents:SetChecked(BohemkaDKPConfig.showProfessions)
    playerReagents:SetScript("OnClick", function(self)
        BohemkaDKPConfig.showOwnReagents = self:GetChecked()
        if BohemkaDKP.selectedCraftButton then
            BohemkaDKP:UpdateCrafts()
            BohemkaDKP:SelectCraftButton(BohemkaDKP.selectedCraftButton)
        end
    end)

    font = playerReagents:CreateFontString("$parentText","ARTWORK", "GameFontNormalSmall")
    font:SetText("Own reagents")
    font:SetPoint("RIGHT", playerReagents, "LEFT", -5, 1)
    table.insert(UISpecialFrames, f:GetName())
end
function BohemkaDKP:CreateGuildCraftListFrame()
    local f = CreateFrame("Frame", "GuildCraftListFrame", UIParent, BackdropTemplateMixin and "BackdropTemplate" or nil)
    f:SetSize(384, 512)
    f:SetPoint("TOPLEFT", GuildFrame, "TOPRIGHT", 0, 14)
    f:SetHitRectInsets(0, 34, 0, 75)
    f:SetFrameStrata("HIGH")
    f:RegisterForDrag("LeftButton")
    f:SetScript("OnDragStart", f.StartMoving)
    f:SetScript("OnDragStop", f.StopMovingOrSizing)
    f:SetScript("OnHide", function()
        BohemkaDKP:PositionGuildCraftFrame()
    end)
    f:SetScript("OnShow", function()
        BohemkaDKP:PositionGuildCraftFrame()
    end)
    f:Hide()
    f.mode = "single"
    table.insert(UISpecialFrames, f:GetName())

    local clear = CreateFrame("BUTTON", "$parentClear", f, "UIPanelButtonTemplate");
    clear:SetPoint("TOPLEFT", 183 , -409)
    clear:SetText("Clear")
    clear:SetScript("OnClick", function()
        GuildCraftListMemberSearchValue:SetSearchValue()
        GuildCraftListMemberSearchValue:ClearFocus()
    end)
    clear:SetWidth(77)

    local closeBtn = CreateFrame("BUTTON", "$parentCloseButton", f, "UIPanelButtonTemplate");
    closeBtn:SetPoint("LEFT", clear, "RIGHT", 3, 0)
    closeBtn:SetText("Close")
    closeBtn:SetScript("OnClick", function()
        f:Hide()
    end)
    closeBtn:SetWidth(77)

    local close = CreateFrame("BUTTON", "$parentClose", f, "UIPanelCloseButton");
    close:SetPoint("TOPRIGHT", f, "TOPRIGHT", -30, -8)

    local portrait = f:CreateTexture("$parentPortrait", "BACKGROUND")
    portrait:SetSize(60,60)
    portrait:SetPoint("TOPLEFT", 7, -6)

    local border1 = f:CreateTexture("$parentBorderTopLeft", "BORDER")
    border1:SetSize(256,256)
    border1:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-TopLeft")
    border1:SetPoint("TOPLEFT")

    local border2 = f:CreateTexture("$parentBorderTopRight", "BORDER")
    border2:SetSize(128,256)
    border2:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-TopRight")
    border2:SetPoint("TOPRIGHT")

    local border3 = f:CreateTexture("$parentBorderBotLeft", "BORDER")
    border3:SetSize(256,256)
    border3:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-BotLeft")
    border3:SetPoint("BOTTOMLEFT")

    local border4 = f:CreateTexture("$parentBorderBotRight", "BORDER")
    border4:SetSize(128,256)
    border4:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-BotRight")
    border4:SetPoint("BOTTOMRIGHT")

    local font = f:CreateFontString("$parentTitle","BORDER", "GameFontNormal")
    font:SetText("Profession")
    font:SetPoint("TOP", 0, -18)


    --
    --local skillBorder1 = f:CreateTexture("$parentSkillBorderLeft", "ARTWORK")
    --skillBorder1:SetSize(256,8)
    --skillBorder1:SetTexture("Interface\\TradeSkillFrame\\UI-TradeSkill-SkillBorder")
    --skillBorder1:SetPoint("TOPLEFT", 63, -50)
    --skillBorder1:SetTexCoord(0, 1.0, 0, 0.25)
    --
    --local skillBorder2 = f:CreateTexture("$parentSkillBorder", "ARTWORK")
    --skillBorder2:SetSize(28,8)
    --skillBorder2:SetTexture("Interface\\TradeSkillFrame\\UI-TradeSkill-SkillBorder")
    --skillBorder2:SetPoint("LEFT", GuildCraftListFrameSkillBorderLeft, "RIGHT", 0, 0)
    --skillBorder2:SetTexCoord(0, 0.109375, 0.25, 0.5)


    --local skillBorder3 = f:CreateTexture("$parentHorizontalSkillBorderLeft", "ARTWORK")
    --skillBorder3:SetSize(256,16)
    --skillBorder3:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-HorizontalBar")
    --skillBorder3:SetPoint("TOPLEFT", 15, -221)
    --skillBorder3:SetTexCoord(0, 1.0, 0, 0.25)
    --
    --local skillBorder4 = f:CreateTexture("$parentHorizontalSkillBorder", "ARTWORK")
    --skillBorder4:SetSize(75,16)
    --skillBorder4:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-HorizontalBar")
    --skillBorder4:SetPoint("LEFT", GuildCraftListFrameHorizontalSkillBorderLeft, "RIGHT", 0, 0)
    --skillBorder4:SetTexCoord(0, 0.29296875, 0.25, 0.5)

    local skillRankFrame = CreateFrame("StatusBar", "$parentSkillRankFrame", f)
    skillRankFrame:SetMinMaxValues(0, 1)
    skillRankFrame:SetValue(0)
    skillRankFrame:SetSize(268, 15)
    skillRankFrame:SetPoint("TOPLEFT", 73, -37)
    skillRankFrame:SetStatusBarTexture("Interface\\PaperDollInfoFrame\\UI-Character-Skills-Bar")
    skillRankFrame:SetStatusBarColor(0.25, 0.25, 0.75)

    local skillName = skillRankFrame:CreateFontString("$parentSkillName","ARTWORK", "GameFontNormalSmall")
    skillName:SetText("Profession")
    skillName:SetPoint("LEFT", 6, 1)

    local skillRank = skillRankFrame:CreateFontString("$parentSkillRank","ARTWORK", "GameFontHighlightSmall")
    skillRank:SetText("0/0")
    skillRank:SetSize(128, 0)
    skillRank:SetPoint("LEFT", "$parentSkillName", "RIGHT", 13, 0)
    skillRank:SetJustifyH("LEFT")

    local skillRankBg = skillRankFrame:CreateTexture("$parentBackground", "BACKGROUND")
    skillRankBg:SetColorTexture(1, 1, 1, 0.2)

    local skillRankBorder = CreateFrame("Button", "$parentBorder", skillRankFrame)
    skillRankBorder:SetSize(281, 32)
    skillRankBorder:SetPoint("LEFT", -5, 0)
    skillRankBorder:SetNormalTexture("Interface\\PaperDollInfoFrame\\UI-Character-Skills-BarBorder")

    local highlightFrame = CreateFrame("Frame", "$parentHighlight", f, BackdropTemplateMixin and "BackdropTemplate" or nil)
    highlightFrame:SetSize(297, 16)
    highlightFrame:SetPoint("TOPLEFT", 0, -30)
    highlightFrame:SetFrameStrata("HIGH")
    highlightFrame:Hide()

    local tx = highlightFrame:CreateTexture("$parentTex", "ARTWORK")
    tx:SetTexture("Interface\\Buttons\\UI-Listbox-Highlight2")
    tx:SetAllPoints(true)

    local prevSkillFrame
    for i=1, CRAFTS_LIST_DISPLAYED do
        local skillFrame = CreateFrame("Button", "$parentSkillFrame"..i, f, "SecureHandlerClickTemplate")
        local skillFrameText = skillFrame:CreateFontString("$parentText","ARTWORK", "GameFontNormal")
        skillFrameText:SetText("Recipe")
        skillFrameText:SetFont("Fonts\\FRIZQT__.TTF", 11)
        skillFrameText:SetSize(192, 11)
        skillFrameText:SetPoint("LEFT", 8, 0)
        skillFrameText:SetJustifyH("LEFT")

        skillFrame:SetSize(CRAFT_SKILL_BUTTON_WIDTH, CRAFTS_LIST_ROW_HEIGHT)
        skillFrame:SetFontString(skillFrameText)
        local skillFrameFont = CreateFont(skillFrame:GetName().."Font")
        skillFrameFont:SetFontObject("GameFontNormal")
        skillFrame:SetNormalFontObject(skillFrameFont)
        skillFrame:SetHighlightFontObject("GameFontHighlight")
        skillFrame:SetDisabledFontObject("GameFontDisable")
        skillFrame:Show()
        skillFrame.collapsed = false
        if not prevSkillFrame then
            skillFrame:SetPoint("TOPLEFT", 22, -96)
        else
            skillFrame:SetPoint("TOPLEFT", prevSkillFrame, "BOTTOMLEFT", 0, 0)
        end
        skillFrame:SetScript("OnClick", function(self)
            if self.config then
                if self.config.type == "header" then
                    BohemkaDKPConfig.collapsed[self.config.profName] = not BohemkaDKPConfig.collapsed[self.config.profName]
                    BohemkaDKP:RenderCraftsMulti(GuildCraftListMemberSearchValue:GetSearchValue())
                end
                if self.config.profession then
                    if GuildCraftListMemberSearchValue.blockSearch then
                        BohemkaDKP:RenderCrafts(self.config.playerName, self.config.profession, Crafts[self.config.playerName][self.config.profession.name])
                    else
                        local searchText = GuildCraftListMemberSearchValue:GetText()
                        BohemkaDKP:RenderFilteredCrafts(searchText, self.config.profession, self.config.playerName)
                    end

                    BohemkaDKP:SelectCraftListButton(self)
                end
            end
        end)

        local minusBtn = skillFrame:CreateTexture("$parentNormal", "ARTWORK")
        minusBtn:SetTexture("Interface\\Buttons\\UI-MinusButton-UP")
        minusBtn:SetPoint("LEFT", 3, 0)
        minusBtn:SetSize(16,16)
        minusBtn:SetAlpha(0)

        local disabledBtn = skillFrame:CreateTexture("$parentDisabled", "ARTWORK")
        disabledBtn:SetTexture("Interface\\Buttons\\UI-PlusButton-Disabled")
        disabledBtn:SetPoint("LEFT", 3, 0)
        disabledBtn:SetSize(16,16)
        disabledBtn:SetAlpha(0)

        local highlightBtn = skillFrame:CreateTexture("$parentHighlight", "ARTWORK")
        highlightBtn:SetTexture("Interface\\Buttons\\UI-PlusButton-Hilight")
        highlightBtn:SetPoint("LEFT", 3, 0)
        highlightBtn:SetSize(16,16)
        highlightBtn:SetAlpha(0)

        skillFrame:SetNormalTexture(minusBtn)
        skillFrame:SetDisabledTexture(disabledBtn)
        skillFrame:SetHighlightTexture(highlightBtn)

        local skillButtonRankFrame = CreateFrame("StatusBar", "$parentSkillButtonRankFrame", skillFrame)
        skillButtonRankFrame:SetMinMaxValues(0, 1)
        skillButtonRankFrame:SetValue(1)
        skillButtonRankFrame:SetSize(50, 10)
        skillButtonRankFrame:SetPoint("RIGHT", skillFrame, "RIGHT", -5, 0)
        skillButtonRankFrame:SetStatusBarTexture("Interface\\PaperDollInfoFrame\\UI-Character-Skills-Bar")
        skillButtonRankFrame:SetStatusBarColor(0.25, 0.25, 0.75)



        local skillFrameTextRight = skillFrame:CreateFontString("$parentTextRight","ARTWORK", "GameFontNormal")
        skillFrameTextRight:SetJustifyH("RIGHT")
        skillFrameTextRight:SetSize(30, 9)
        skillFrameTextRight:SetPoint("RIGHT", skillButtonRankFrame, "LEFT", -5, 0)
        skillFrameTextRight:SetFont("Fonts\\FRIZQT__.TTF", 9)

        local skillFrameSpec = CreateFrame("Frame", "$parentSpec", skillFrame)
        skillFrameSpec:SetSize(12, 12)
        skillFrameSpec:SetPoint("RIGHT", skillFrameTextRight, "LEFT", -3, 0)

        skillFrameSpec:SetScript("OnEnter", function(self)
            if self.tooltip then
                GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 0);
                GameTooltip:SetText(self.tooltip);
                GameTooltip:Show();
            end
        end)
        skillFrameSpec:SetScript("OnLeave", function()
            GameTooltip:Hide();
        end)

        local skillFrameSpecText = skillFrameSpec:CreateFontString("$parentSkillRank","ARTWORK", "GameFontHighlightSmall")
        skillFrameSpecText:SetPoint("CENTER", 1, 0)
        skillFrameSpecText:SetJustifyH("CENTER")
        skillFrameSpecText:SetFont("Fonts\\FRIZQT__.TTF", 9, "OUTLINE")
        skillFrameSpec.text = skillFrameSpecText

        local skillFrameSpecBg = skillFrameSpec:CreateTexture("$parentBackground", "ARTWORK")
        skillFrameSpecBg:SetAllPoints(true)

        local skillButtonRank = skillButtonRankFrame:CreateFontString("$parentSkillRank","ARTWORK", "GameFontHighlightSmall")
        skillButtonRank:SetText("375/375")
        skillButtonRank:SetPoint("CENTER", skillButtonRankFrame)
        skillButtonRank:SetJustifyH("CENTER")
        skillButtonRank:SetFont("Fonts\\FRIZQT__.TTF", 8)

        local skillButtonBg = skillButtonRankFrame:CreateTexture("$parentBackground", "BACKGROUND")
        skillButtonBg:SetColorTexture(0,0, 0, 0.8)
        skillButtonBg:SetAllPoints(true)

        local skillButtonBorder = CreateFrame("Button", "$parentBorder", skillButtonRankFrame)
        skillButtonBorder:SetSize(50, 24)
        skillButtonBorder:SetPoint("LEFT", -0, 0)
        skillButtonBorder:SetNormalTexture("Interface\\PaperDollInfoFrame\\UI-Character-Skills-BarBorder")

        prevSkillFrame = skillFrame
    end

    local scroll = CreateFrame('ScrollFrame', '$parentScrollFrame', f, 'FauxScrollFrameTemplate')
    scroll:SetSize(296, CRAFTS_LIST_DISPLAYED * CRAFTS_LIST_ROW_HEIGHT)
    scroll:SetPoint('TOPRIGHT', f, 'TOPRIGHT', -67, -96)


    local scrollTop = scroll:CreateTexture("$parentTop", "BACKGROUND")
    scrollTop:SetSize(29,102)
    scrollTop:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ScrollBar")
    scrollTop:SetPoint("TOPLEFT", scroll, "TOPRIGHT", -2, 4)
    scrollTop:SetTexCoord(0, 0.445, 0, 0.4)

    local scrollBottom = scroll:CreateTexture("$parentBottom", "BACKGROUND")
    scrollBottom:SetSize(29,106)
    scrollBottom:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ScrollBar")
    scrollBottom:SetPoint("BOTTOMLEFT", scroll, "BOTTOMRIGHT", -2, -2)
    scrollBottom:SetTexCoord(0.515625, 0.960625, 0, 0.4140625)

    local scrollMiddle = scroll:CreateTexture("$parentMiddle", "BACKGROUND")
    scrollMiddle:SetSize(29,1)
    scrollMiddle:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ScrollBar")
    scrollMiddle:SetPoint("TOP", scrollTop, "BOTTOM", 0, 0)
    scrollMiddle:SetPoint("BOTTOM", scrollBottom, "TOP", 0, 0)
    scrollMiddle:SetTexCoord(0, 0.445, 0.75, 1)

    scroll:SetScript("OnVerticalScroll", function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, CRAFTS_LIST_ROW_HEIGHT, function()
            BohemkaDKP:UpdateCraftList()
        end)
    end)



    local e = CreateFrame("EditBox", "GuildCraftListMemberSearchValue", f)
    e:SetWidth(150)
    e:SetHeight(33)
    e:SetPoint("TOPLEFT", f, 28, -403)
    e:SetFont("Fonts\\FRIZQT__.TTF", 11)
    e:SetTextInsets(0,0,0,0)
    e:SetMultiLine(false)
    e:SetAutoFocus(false)
    e:SetJustifyH("LEFT")
    e.blockSearch = true
    e:SetScript( "OnEscapePressed", function( )
        e:ClearFocus()
    end )
    local searchText = self:colorize("Search", self.COLOR.GRAY)
    e:SetText(searchText)
    e:SetScript("OnEnterPressed", function(self)
        self:ClearFocus()
    end)
    e:SetScript("OnTextChanged", function(self)
        if self.blockSearch then
            return
        end
        BohemkaDKP:RenderCraftsMulti(self:GetText())
    end)
    e:SetScript("OnEditFocusGained", function(self)
        if self:GetText() == searchText then
            self:SetText("")
            self.blockSearch = false
        end
    end)

    e:SetScript("OnEditFocusLost", function(self)
        if self:GetText() == "" then
            self:SetText(searchText)
            self.blockSearch = true
        end
    end)
    e.GetSearchValue = function(self)
        return self:GetText() == searchText and "" or self:GetText()
    end
    e.SetSearchValue = function (self, value)
        if not value then
            self:SetText(searchText)
            self.blockSearch = true
        else
            self:SetText(value)
            self.blockSearch = false
        end
        BohemkaDKP:RenderCraftsMulti(value)
    end
    local showOffline = CreateFrame("CheckButton", "$parentOfflineMembers", f, "UICheckButtonTemplate")
    showOffline:SetPoint("TOPLEFT", f, 170, -55)
    showOffline:SetSize(20, 20)
    showOffline:SetChecked(BohemkaDKPConfig.showOfflineMembers)
    showOffline:SetScript("OnClick", function(self)
        BohemkaDKPConfig.showOfflineMembers = self:GetChecked()
        BohemkaDKP:RenderCraftsMulti(GuildCraftListMemberSearchValue:GetSearchValue())
    end)

    font = showOffline:CreateFontString("$parentText","ARTWORK", "GameFontNormalSmall")
    font:SetText("Offline Members")
    font:SetPoint("RIGHT", showOffline, "LEFT", -5, 1)
end
function BohemkaDKP:RenderFilteredCrafts(searchValue, profession, playerName)
    local crafts = self:FilterCrafts(searchValue, profession.name, playerName)
    self:RenderCrafts(playerName, profession, crafts)
end
function BohemkaDKP:ResetGuildCraftScroll()
    FauxScrollFrame_SetOffset(GuildCraftFrameScrollFrame, 0)
    GuildCraftFrameScrollFrameScrollBar:SetMinMaxValues(0, 0)
	GuildCraftFrameScrollFrameScrollBar:SetValue(0)
end
function BohemkaDKP:ResetGuildCraftListScroll()
    FauxScrollFrame_SetOffset(GuildCraftListFrameScrollFrame, 0)
    GuildCraftListFrameScrollFrameScrollBar:SetMinMaxValues(0, 0)
	GuildCraftListFrameScrollFrameScrollBar:SetValue(0)
end
function BohemkaDKP:RenderCraftsMulti(searchValue)
    GuildCraftListFrameTitle:SetText("Guild Professions")
    if searchValue and #searchValue > 0 then
        self:ResetGuildCraftListScroll()
    end
    GuildCraftListFrameSkillRankFrame:Hide()
    SetPortraitToTexture(GuildCraftListFramePortrait, 134939)
    local tmp = {}
    local icons = {}
    for playerName, professions in pairs(Crafts) do
        if BohemkaDKPConfig.showOfflineMembers or self:IsPlayerOnline(playerName) then
            for profName, profession in pairs(professions) do
                if not tmp[profName] then
                    tmp[profName] = {}
                end
                if RosterData.professions[playerName] then
                    for _, data in ipairs(RosterData.professions[playerName]) do
                        if data.name == profName then
                            tmp[profName][playerName] = { data = data }
                            icons[profName] = data.icon
                            if BohemkaDKP.PROFESSIONS_SPEC[profName] then
                                for _, data2 in ipairs(RosterData.professions[playerName]) do
                                    for specName, _ in pairs(BohemkaDKP.PROFESSIONS_SPEC[profName]) do
                                        if data2.name == specName then
                                            icons[specName] = data2.icon
                                            tmp[profName][playerName].spec = data2
                                            break
                                        end
                                    end

                                end
                            end
                            break
                        end
                    end
                    if tmp[profName][playerName] then
                        local totalRecipes = 0
                        local add = false
                        for craftName, _ in pairs(profession) do
                            if searchValue then
                                if not add and string.find(strlower(craftName), searchValue) then
                                    add = true
                                end
                            else
                                add = true
                            end
                            totalRecipes = totalRecipes + 1
                        end
                        if add then
                            tmp[profName][playerName].profession = profession
                            tmp[profName][playerName].totalRecipes = totalRecipes
                        else
                            tmp[profName][playerName] = nil
                        end
                    end
                end
            end
        end
    end
    local professionNames = {}
    for profName, players in pairs(tmp) do
        local count = 0
        for _ in pairs(players) do count = count + 1 end
        if count > 0 then
            professionNames[#professionNames + 1] = profName
        end
    end
    table.sort(professionNames, function (a, b) return a < b end)
    local buttons = {}
    for i, profName in ipairs(professionNames) do
        local players = tmp[profName]
        local playersOrdered = {}
        for playerName, profession in pairs(players) do
            playersOrdered[#playersOrdered + 1] = { playerName = playerName, profession = profession }
        end
        table.sort(playersOrdered, function (a, b) return a.profession.totalRecipes > b.profession.totalRecipes end)
        local icon = icons[profName]
        local text = profName
        if icon then
            text = "|T"..icon..":12:12:0:0|t "..text
        end
        buttons[#buttons + 1] = {
            title = text,
            font = "GameFontNormalLeft",
            type = "header",
            profName = profName
        }
        if not BohemkaDKPConfig.collapsed[profName] then
            for _, player in ipairs(playersOrdered) do
                local playerName = player.playerName
                local profession = player.profession
                local isOnline = self:IsPlayerOnline(playerName)
                local data = profession.data
                local title
                local classColor = self:GetClassColor(playerName)
                local shortName = strsplit("-", playerName)
                local rightFontColor
                if isOnline then
                    title = shortName
                else
                    title = shortName
                    classColor = self.COLOR.GRAY
                    rightFontColor = self.COLOR.GRAY
                end

                buttons[#buttons + 1] = {
                    title = "        "..title,
                    statusBar = {
                        rank = data.rank,
                        maxRank = data.maxRank,
                    },
                    playerName = playerName,
                    profession = data,
                    highlightColor = classColor,
                    fontColor = classColor,
                    rightTitle = "["..profession.totalRecipes.."]",
                    rightFontColor = rightFontColor,
                    spec = profession.spec
                }
            end
        end
    end
    GuildCraftListFrame.buttons = buttons
    FauxScrollFrame_Update(GuildCraftListFrameScrollFrame, #buttons, CRAFTS_LIST_DISPLAYED, CRAFTS_LIST_ROW_HEIGHT)
    self:UpdateCraftList()
end
function BohemkaDKP:UpdateCraftList()
    if not GuildCraftListFrame:IsVisible() then
        return
    end
    GuildCraftListFrameHighlight:Hide()
    local skillOffset = FauxScrollFrame_GetOffset(GuildCraftListFrameScrollFrame)
    local hasScroll = #GuildCraftListFrame.buttons > CRAFTS_LIST_DISPLAYED
    local isSelected = false
    FauxScrollFrame_Update(GuildCraftListFrameScrollFrame, #GuildCraftListFrame.buttons, CRAFTS_LIST_DISPLAYED, CRAFTS_LIST_ROW_HEIGHT)
    for i=1,CRAFTS_LIST_DISPLAYED do
        local skillButton = _G["GuildCraftListFrameSkillFrame"..i]
        local skillButtonFont = _G["GuildCraftListFrameSkillFrame"..i.."Font"]
        local skillButtonSpec = _G["GuildCraftListFrameSkillFrame"..i.."Spec"]
        local skillButtonSpecBg = _G["GuildCraftListFrameSkillFrame"..i.."SpecBackground"]
        local skillButtonTextRight = _G["GuildCraftListFrameSkillFrame"..i.."TextRight"]
        local skillButtonStatusBar = _G["GuildCraftListFrameSkillFrame"..i.."SkillButtonRankFrame"]
        local skillButtonStatusBarText = _G["GuildCraftListFrameSkillFrame"..i.."SkillButtonRankFrameSkillRank"]
        local skillButtonNormal = _G["GuildCraftListFrameSkillFrame"..i.."Normal"]
        local skillButtonDisabled = _G["GuildCraftListFrameSkillFrame"..i.."Disabled"]
        local skillButtonHighlight = _G["GuildCraftListFrameSkillFrame"..i.."Highlight"]
        local button = GuildCraftListFrame.buttons[i + skillOffset]
        if button then
            skillButton:Show()
            if not BohemkaDKPConfig.collapsed[button.profName] then
                skillButton:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up");
            else
                skillButton:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
            end
            skillButton.config = button
            if GuildCraftFrame.playerName and button.playerName == GuildCraftFrame.playerName and GuildCraftFrame.profession.name == button.profession.name then
                self:SelectCraftListButton(skillButton)
                isSelected = true
            end
            skillButton:SetNormalFontObject(button.font or skillButtonFont)
            local fontColor = button.fontColor and button.fontColor or BohemkaDKP.SkillTypeColor[button.type]
            local rightFontColor = button.rightFontColor and button.rightFontColor or { r = 0.95, g = 0.95, b = 0.95 }
            skillButtonFont:SetTextColor(fontColor.r,fontColor.g,fontColor.b)
            skillButtonTextRight:SetTextColor(rightFontColor.r,rightFontColor.g,rightFontColor.b)
            local specText = ""
            if button.spec and button.spec.icon then
                skillButtonSpecBg:SetTexture(self:GetProfessionIcon(button.spec))
                skillButtonSpec.tooltip = button.spec.name
            else
                skillButtonSpecBg:SetTexture(nil)
                skillButtonSpec.tooltip = nil
            end
            skillButtonSpec.text:SetText(specText)
            if hasScroll then
                skillButton:SetWidth(CRAFT_SKILL_BUTTON_WIDTH)
            else
                skillButton:SetWidth(CRAFT_SKILL_BUTTON_WIDTH + 22)
            end
            skillButtonTextRight:SetText(button.rightTitle)
            if button.type == "header" then
                skillButtonNormal:SetAlpha(1)
                skillButtonDisabled:SetAlpha(1)
                skillButtonHighlight:SetAlpha(1)
                skillButton:SetText("    "..button.title)
            else
                skillButtonNormal:SetAlpha(0)
                skillButtonDisabled:SetAlpha(0)
                skillButtonHighlight:SetAlpha(0)
                skillButton:SetText(button.title)
            end
            if button.statusBar then
                skillButtonStatusBar:Show()
                skillButtonStatusBar:SetMinMaxValues(0, button.statusBar.maxRank or 375)
                skillButtonStatusBar:SetValue(button.statusBar.rank)
                skillButtonStatusBarText:SetText(button.statusBar.rank.."/"..(button.statusBar.maxRank or "-"));
            else
                skillButtonStatusBar:Hide()
            end
            self:UpdateCraftListHighlight(i)
        else
            skillButton:Hide()
        end
    end
    if not isSelected then
        GuildCraftListFrameHighlight:Hide()
        GuildCraftListFrameHighlightTex:SetVertexColor(0, 0, 0, 0)
    end
end
function BohemkaDKP:SelectCraftListButton(button)
    self.selectedCraftListButton = button and button.config or button
    for i=1,CRAFTS_LIST_DISPLAYED do
        local skillButton = _G["GuildCraftListFrameSkillFrame"..i]
        if button then
            self:UpdateCraftListHighlight(i)
        end
    end
end
function BohemkaDKP:UpdateCraftListHighlight(i)
    local skillOffset = FauxScrollFrame_GetOffset(GuildCraftListFrameScrollFrame);
    local skillButton = _G["GuildCraftListFrameSkillFrame"..i]
    local button = GuildCraftListFrame.buttons[i + skillOffset]
    if button and self.selectedCraftListButton and button == self.selectedCraftListButton then
        GuildCraftListFrameHighlight:Show()
        GuildCraftListFrameHighlight:SetPoint("TOPLEFT", skillButton, "TOPLEFT", 0, 0);
        GuildCraftListFrameHighlight:SetWidth(skillButton:GetWidth())
        skillButton:LockHighlight()
        local color = BohemkaDKP.SkillTypeColor[button.type] or button.highlightColor
        if color then
            GuildCraftListFrameHighlightTex:SetVertexColor(color.r, color.g, color.b, 1)
        end
        return true
    else
        skillButton:UnlockHighlight()
        return false
    end
end
function BohemkaDKP:PositionGuildCraftFrame()
    GuildCraftFrame:ClearAllPoints()
    local point, relativeTo, relativePoint, xOfs, yOfs = FriendsFrame:GetPoint()
    if GuildCraftListFrame:IsVisible() then
        if FriendsFrame:IsVisible() then
            GuildCraftListFrame:SetPoint("TOPLEFT", FriendsFrame, "TOPRIGHT", 0, GuildCraftFrame.detachedY)
        else
            GuildCraftListFrame:SetPoint("TOPLEFT", UIParent, xOfs, yOfs)
        end

        GuildCraftFrame:SetPoint("TOPLEFT", GuildCraftListFrame, "TOPRIGHT", GuildCraftFrame.attachedX, 0)
    else
        if FriendsFrame:IsVisible() then
            GuildCraftFrame:SetPoint("TOPLEFT", FriendsFrame, "TOPRIGHT", 0, GuildCraftFrame.detachedY)
        else
            GuildCraftFrame:SetPoint("TOPLEFT", UIParent, xOfs, yOfs)
        end

    end
end
function BohemkaDKP:RenderCrafts(playerName, profession, crafts)
    GuildCraftFrame:Show()
    self:PositionGuildCraftFrame()
    self:ResetGuildCraftScroll()
    GuildCraftFrameSkillRankFrame:SetMinMaxValues(0, profession.maxRank or 375)
    GuildCraftFrameSkillRankFrameSkillName:SetText(format(TRADE_SKILL_TITLE, profession.name));
    GuildCraftFrameSkillRankFrame:SetValue(profession.rank)
    GuildCraftFrameSkillRankFrameSkillRank:SetText(profession.rank.."/"..(profession.maxRank or "-"));
    GuildCraftFrameTitle:SetText(self:AddClassColorToName(playerName).."'s "..profession.name)
    SetPortraitToTexture(GuildCraftFramePortrait, profession.icon)
    local tmp = {}
    for name, data in pairs(crafts) do
        table.insert(tmp, {name=name, data=data})
    end
    table.sort(tmp, function (a, b) return a.data.id < b.data.id end)
    GuildCraftFrame.crafts = tmp
    GuildCraftFrame.profession = profession
    GuildCraftFrame.playerName = playerName
    self:UpdateCrafts()
    self:UpdateCraftList()
    self:SelectCraftButton(GuildCraftFrameSkillFrame1)
end
function BohemkaDKP:UpdateCrafts()
    FauxScrollFrame_Update(GuildCraftFrameScrollFrame, #GuildCraftFrame.crafts, CRAFTS_DISPLAYED, 16, nil, nil, nil);
    local skillOffset = FauxScrollFrame_GetOffset(GuildCraftFrameScrollFrame);
    local hasScroll = GuildCraftFrameScrollFrame:IsVisible()
    local isSelected = false
    for i=1,CRAFTS_DISPLAYED do
        local craft = GuildCraftFrame.crafts[i + skillOffset]
        local skillButton = _G["GuildCraftFrameSkillFrame"..i]
        skillButton.craft = craft
        if craft then
            local text = craft.name
            local available = 0
            if BohemkaDKPConfig.showOwnReagents then
                local count = nil
                for _, reagent in ipairs(craft.data.reagents) do
                    local playerCount = GetItemCount(reagent.link, true)
                    local tmp = math.floor(playerCount / reagent.count)
                    if count == nil then
                        count = tmp
                    else
                        if tmp < count then
                            count = tmp
                        end
                    end
                end
                available = count
            else
                available = craft.data.available
            end
            if available > 0 then
                text = text.." ["..available.."]"
            end
            skillButton:SetText(text)
            local color = self.SkillTypeColor[craft.data.type]
            skillButton.craft = craft
            if color then
                skillButton:SetNormalFontObject(color.font);
            end
            if hasScroll then
                skillButton:SetWidth(CRAFT_SKILL_BUTTON_WIDTH)
            else
                skillButton:SetWidth(CRAFT_SKILL_BUTTON_WIDTH + 22)
            end
        else
            skillButton:SetText("")
        end

        if self:UpdateCraftHighlight(i) then
            isSelected = true
        end
    end

    if not isSelected then
        GuildCraftFrameHighlight:Hide()
        GuildCraftFrameHighlightTex:SetVertexColor(0, 0, 0, 0)
    end
end
function BohemkaDKP:UpdateCraftHighlight(i)
    local skillOffset = FauxScrollFrame_GetOffset(GuildCraftFrameScrollFrame);
    local skillButton = _G["GuildCraftFrameSkillFrame"..i]
    local craft = GuildCraftFrame.crafts[i + skillOffset]
    if craft and self.selectedCraft and craft == self.selectedCraft then
        GuildCraftFrameHighlight:Show()
        GuildCraftFrameHighlight:SetPoint("TOPLEFT", skillButton, "TOPLEFT", 0, 0);
        GuildCraftFrameHighlight:SetWidth(skillButton:GetWidth())
        skillButton:LockHighlight()
        local color = BohemkaDKP.SkillTypeColor[self.selectedCraft.data.type]
        if color then
            GuildCraftFrameHighlightTex:SetVertexColor(color.r, color.g, color.b, 1)
        end
        return true
    else
        skillButton:UnlockHighlight()
        return false
    end
end
function BohemkaDKP:SelectCraftButton(button)
    GuildCraftFrameHighlight:Hide()
    BohemkaDKP.selectedCraftButton = button
    BohemkaDKP.selectedCraft = button and button.craft or button
    GuildCraftFrameScrollDetailFrame:Hide()

    for i=1,CRAFTS_DISPLAYED do
        local skillButton = _G["GuildCraftFrameSkillFrame"..i]
        if button then
            BohemkaDKP:UpdateCraftHighlight(i)
        end
        if button and button.craft and button == skillButton then
            GuildCraftFrameScrollDetailFrame:Show()
            GuildCraftFrameScrollDetailFrameChildFrameSkillIconTexture:SetTexture(button.craft.data.icon)
            GuildCraftFrameScrollDetailFrameChildFrameSkillIcon.itemLink = button.craft.data.link
            local maxMade = button.craft.data.max
            local minMade = button.craft.data.min
            local iconText = GuildCraftFrameScrollDetailFrameChildFrameSkillIconCount
            if ( maxMade > 1 ) then
                if ( minMade == maxMade ) then
                    iconText:SetText(minMade);
                else
                    iconText:SetText(minMade.."-"..maxMade);
                end
                if ( iconText:GetWidth() > 39 ) then
                    iconText:SetText("~"..floor((minMade + maxMade)/2));
                end
            else
                iconText:SetText("");
            end
            if button.craft.data.cooldown and button.craft.data.cooldown > 0 then
                GuildCraftFrameScrollDetailFrameChildFrameCooldown:SetText(COOLDOWN_REMAINING.." "..SecondsToTime(button.craft.data.cooldown))
            else
                GuildCraftFrameScrollDetailFrameChildFrameCooldown:SetText("")
            end
            GuildCraftFrameScrollDetailFrameChildFrameSkillName:SetText(button.craft.name)
            if button.craft.data.desc and button.craft.data.desc ~= " " then
                GuildCraftFrameScrollDetailFrameChildFrameDescription:SetText(button.craft.data.desc);
                GuildCraftFrameScrollDetailFrameChildFrameReagentLabel:SetPoint("TOPLEFT", GuildCraftFrameScrollDetailFrameChildFrameDescription, "BOTTOMLEFT", 0, -10);
            else
                GuildCraftFrameScrollDetailFrameChildFrameDescription:SetText("");
                GuildCraftFrameScrollDetailFrameChildFrameReagentLabel:SetPoint("TOPLEFT", GuildCraftFrameScrollDetailFrameChildFrameDescription, "TOPLEFT", 0, 0);
            end
            local creatable = 1
            for j=1,8 do
                local reagent = button.craft.data.reagents[j]
                local reagentFrame = _G["GuildCraftFrameScrollDetailFrameChildFrameSkillReagent"..j]
                local name = _G["GuildCraftFrameScrollDetailFrameChildFrameSkillReagent"..j.."Name"]
                local count = _G["GuildCraftFrameScrollDetailFrameChildFrameSkillReagent"..j.."Count"]
                if reagentFrame then
                    if reagent then
                        reagentFrame:Show()
                        reagentFrame.itemLink = reagent.link
                        SetItemButtonTexture(reagentFrame, reagent.texture)
                        local playerReagentCount = BohemkaDKPConfig.showOwnReagents and GetItemCount(reagent.link, true) or reagent.playerCount
                        local reagentName = reagent.link and reagent.link:match('%[(.+)%]') or "???"
                        name:SetText(reagentName)
                        if ( playerReagentCount < reagent.count ) then
                            SetItemButtonTextureVertexColor(reagentFrame, 0.5, 0.5, 0.5);
                            name:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
                            creatable = nil;
                        else
                            SetItemButtonTextureVertexColor(reagentFrame, 1.0, 1.0, 1.0);
                            name:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
                        end

                        if reagent.playerCount >= 100 then
                            playerReagentCount = "*";
                        end
                        count:SetText(playerReagentCount.." /"..reagent.count);
                    else
                        reagentFrame:Hide()
                    end
                end
            end
        end
    end
end
function BohemkaDKP:ScrollToSelectedCraft()
    if not GuildCraftListFrame:IsVisible() then
        return
    end
    local selectedItem = 0
    local skillOffset = FauxScrollFrame_GetOffset(GuildCraftListFrameScrollFrame)
    for i, button in ipairs(GuildCraftListFrame.buttons) do
        if GuildCraftFrame.playerName and button.playerName == GuildCraftFrame.playerName and GuildCraftFrame.profession.name == button.profession.name then
            selectedItem = i
            break
        end
    end
    skillOffset = math.max(0, selectedItem - CRAFTS_LIST_DISPLAYED)
    FauxScrollFrame_SetOffset(GuildCraftListFrameScrollFrame, skillOffset)
    GuildCraftListFrameScrollFrameScrollBar:SetValue(skillOffset * CRAFTS_LIST_ROW_HEIGHT)
end
