---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 15.07.2021 17:52
---
---
local _, BohemkaDKP = ...
local LibDeflate = LibStub:GetLibrary("LibDeflate")
local LibSerialize = LibStub("LibSerialize")

BohemkaDKP.cheaters = {}
function BohemkaDKP:GetGuildLog()
    local guildName = GetGuildInfo("player")
    return DKPLog[guildName]
end
function BohemkaDKP:ProcessCheater(fullName, prev, cur)
    self.cheaters[fullName] = true
    self:Print(format("%s %s is a cheater! DKP edited outside of the addon! Change: %d -> %d", self:colorize("WARNING!", self.COLOR.RED), self:AddClassColorToName(fullName), prev, cur))
end
function BohemkaDKP:DetectChanges(fullName, currentDKP)
    if not self.roster[fullName] then
        return
    end
    self.cheaters[fullName] = false
    local prevItem
    local log = self:GetSortedLog(fullName, "DESC")
    for i = #log, 1, -1 do
        local item = log[i]
        if prevItem then
            if prevItem.current ~= item.prev then
                self:ProcessCheater(fullName, prevItem.current, item.prev)
            end
        end
        prevItem = item
    end
    if prevItem and prevItem.current ~= currentDKP then
        self:ProcessCheater(fullName, prevItem.current, currentDKP)
    end
end
function BohemkaDKP:FillExternalEdit(log, fullName)
    return self:FindInconsistencies(log, fullName, function(newLog, prev, cur)
        table.insert(newLog, 1, {
            current = cur or 0,
            prev = prev or 0,
            reason = "External edit"
        })
    end)
end
function BohemkaDKP:FindInconsistencies(log, fullName, cb)
    local prevItem
    local newLog = {}
    for i = #log, 1, -1 do
        local item = log[i]
        if prevItem then
            if prevItem.current ~= item.prev then
                cb(newLog, prevItem.current, item.prev)
            end
        end
        table.insert(newLog, 1, item)
        prevItem = item
    end
    local currentDKP = self:GetCurrentDKP(fullName)
    if prevItem and prevItem.current ~= currentDKP then
        cb(newLog, prevItem.current, currentDKP)
    end
    return newLog
end
function BohemkaDKP:ShareLog(time, fullName, prev, new, reason, editor, external, reverted, wipe)
    self:SendEvent("GUILD", self.EVENT.LOG, time, fullName, prev, new, reason, editor, external or 0, reverted or 0, wipe or 0)
end
function BohemkaDKP:AddReason(frame, reason, reverted)
    local prevItem = self.sortedLog[frame.index + 1]
    self:ShareLog(prevItem.time + 1, frame.fullName, frame.item.prev, frame.item.current, reason, self:GetPlayerName(true),1, reverted)
end
function BohemkaDKP:OnLog(time, fullName, prev, new, reason, editor, external, reverted, wipe, sender)
    if fullName == "all" then
        local isRestore = string.find(reason, "Data restored from")
        local r, timestamp
        if isRestore then
            r, timestamp = strsplit("-", reason)
            timestamp = tonumber(timestamp)
            reason = r.." "..date('%Y/%m/%d %H:%M', timestamp)
        end
        local totalMembers, _, _ = GetNumGuildMembers();
        for i=1, totalMembers do
            local name = GetGuildRosterInfo(i);
            if name then
                local currentDKP = self:GetCurrentDKP(name)
                self:OnLogSingle(0, name, currentDKP, new, reason, editor, external, reverted, wipe, sender)
            end
        end
        if isRestore then
            local pName = self:GetPlayerName(true)
            if sender == pName then
                local data = self:DecodePayload(self:decodeBase64(CurrentDKPLog.backup[timestamp]))
                for _, item in ipairs(data) do
                    self:ProcessEvent(item, _, pName)
                end
                for name, _ in pairs(CurrentDKPLog.current.data) do
                    local log = BohemkaDKP:GetSortedLog(name, "DESC")
                    if log and #log > 0 then
                        local lastItem = log[1]
                        local valueStr = string.format("%05d", lastItem.current)
                        if self.rosterIndex[name] then
                            GuildRosterSetPublicNote(self.rosterIndex[name], valueStr)
                        end
                    end
                end

                self:LogToChunks(0, function(id, data)
                    BohemkaDKP:SendEvent("GUILD", BohemkaDKP.EVENT.PAYLOAD_START, #data, id)
                end)
            end
        end
    else
        self:OnLogSingle(time, fullName, prev, new, reason, editor, external, reverted, wipe, sender)
    end
end
function BohemkaDKP:OnLogSingle(time, fullName, prev, new, reason, editor, external, reverted)
    if not CurrentDKPLog.current.data[fullName] then
        CurrentDKPLog.current.data[fullName] = {}
    end
    time = tonumber(time)
    if not time then
        return
    end
    local isExternal = external == "1"
    reverted = reverted == "1"
    --wipe = wipe == "1"
    --if wipe and not DKPLog.current.data[fullName][time] then
    --    DKPLog.current.data[fullName] = {}
    --    prev = self:GetCurrentDKP(fullName) or prev
    --    self.roster[fullName] = nil
    --end
    local current = tonumber(new)
    CurrentDKPLog.current.data[fullName][time] = {time = time, prev = tonumber(prev), current = current, reason = reason, editor = editor, external = isExternal, reverted = reverted}
    local currentFullName = GetGuildRosterInfo(GetGuildRosterSelection());
    if currentFullName == fullName then
        self:RefreshDKPLog(fullName)
    end
    --if wipe then
    --    if string.find(reason, "Data restored from") then
    --
    --    else
    --        self:OnLogSingle(time + 1, fullName, current, BohemkaDKPConfig.startingDKP, "Initial DKP")
    --    end
    --end
end
function BohemkaDKP:SyncLog()
    self:SendEvent("GUILD", self.EVENT.SYNC_LOG, BohemkaDKPConfig.lastTimeOnline and BohemkaDKPConfig.lastTimeOnline - 360 or 0)
end
function BohemkaDKP:SyncLogFrom(name)
    self:SendEventTo(name, self.EVENT.SYNC_LOG, 0)
end
local syncFrame = CreateFrame("Frame")
function BohemkaDKP:OnSyncLog(since, sender)
    if sender == self:GetPlayerName(true) then
        return
    end
    self:LogToChunks(since, function(id, data)
        BohemkaDKP:SendEventTo(sender, BohemkaDKP.EVENT.PAYLOAD_START, #data, id)
    end)
end
function BohemkaDKP:LogToChunks(since, cb)
    since = tonumber(since)

    local totalPlayers = {}
    local totalItems = 0
    for name, data in pairs(CurrentDKPLog.current.data) do
        local items = {}
        for time, item in pairs(data) do
            if time >= since then
                table.insert(items, item)
                totalItems = totalItems + 1
            end
        end
        if #items > 0 then
            table.insert(totalPlayers, {name, items})
        end
    end
    self:Debug("Syncing", totalItems, "items of", #totalPlayers, "players since", date('%Y/%m/%d %H:%M', tonumber(since)))
    local i = 1
    syncFrame:SetScript("OnUpdate", function()
        if i > #totalPlayers then
            syncFrame:SetScript("OnUpdate", nil)
            --cb(BohemkaDKP:PreparePayloadForSend(chunks))
            return
        end
        local name, items = unpack(totalPlayers[i])
        local chunks = {}
        for _, item in ipairs(items) do
            table.insert(chunks, BohemkaDKP:LogItemToPayload(name, item))
        end
        cb(BohemkaDKP:PreparePayloadForSend(chunks))
        i = i + 1
    end)
end
function BohemkaDKP:LogItemToPayload(name, item)
    return self:PreparePayload(self.EVENT.LOG, item.time, name, item.prev, item.current, item.reason, item.editor or "", item.external and 1 or 0, item.reverted and 1 or 0, item.wipe and 1 or 0)
end
function BohemkaDKP:GetSortedLog(fullName, order)
    local sortFn = {
        ASC = function (a, b) return a.time < b.time end,
        DESC = function (a, b) return a.time > b.time end
    }
    local log = CurrentDKPLog.current.data[fullName]
    local sortedLog = {}
    if log then
        for _, data in pairs(log) do
            table.insert(sortedLog, data)
        end
    end
    table.sort(sortedLog, sortFn[order])
    return sortedLog
end
function BohemkaDKP:DetectChangesAll()
    if self.searchingForCheaters then
        return
    end
    self.searchingForCheaters = true
    local f = BohemkaDKP.EventFrame
    local i = 1
    local total = GetNumGuildMembers()
    f:SetScript("OnUpdate", function()
        if i >= total then
            f:SetScript("OnUpdate", nil)
            BohemkaDKP.searchingForCheaters = false
        end
        local fullName = GetGuildRosterInfo(i);
        BohemkaDKP:DetectChanges(fullName, self:GetCurrentDKP(fullName))
        i = i + 1
    end)
end
function BohemkaDKP:InitDKPLog()
    local guildName = self:GetGuildName(unit)
    if not DKPLog[guildName] then
        DKPLog[guildName] = {
            current = {
                data = {}
            },
            backup = {}
        }
    end
    CurrentDKPLog = DKPLog[guildName]
end
function BohemkaDKP:WipeData(fullName)
    if not fullName then
        return
    end
    if not self:CanWipeData() then
        return
    end
    if true then
        self:Print("This function is disabled because it was badly implemented and requires rework. If you need to clear log make sure everyone in the guild deletes addon file in WTF folder before log in.")
        return
    end
    self:Debug("Wiping data of", fullName)
    SendChatMessage(format("DKP data have been wiped for %s", fullName), "GUILD")
    local time = GetServerTime()
    self:ShareLog(time, fullName, 0, 0, "Data wipe", self:GetPlayerName(true),0, 0, 1)
    C_Timer.After(2, function ()
        if fullName == "all" then
            local totalMembers, _, _ = GetNumGuildMembers();
            for i=1, totalMembers do
                local name = GetGuildRosterInfo(i);
                self.roster[name] = nil
                self:SaveDKP(i, BohemkaDKPConfig.startingDKP, nil, nil, true)
            end
        else
            self:SaveDKP(self.rosterIndex[fullName], BohemkaDKPConfig.startingDKP, nil, nil, true)
        end
    end)
end
function BohemkaDKP:WipeDataAll()
    if not CanEditPublicNote() then
        return
    end
    self:CreateBackup()
    self:WipeData("all")
end
function BohemkaDKP:CreateBackup()
    self:Debug("Backup created")
    if not CurrentDKPLog.backup then
        CurrentDKPLog.backup = {}
    end
    local time = GetServerTime()
    local tmp = {}
    for name, data in pairs(CurrentDKPLog.current.data) do
        for _, item in pairs(data) do
            if not item.wipe then
                table.insert(tmp, BohemkaDKP:LogItemToPayload(name, item))
            end

        end
    end
    CurrentDKPLog.backup[time] = self:encodeBase64(self:EncodePayload(tmp))
    CurrentDKPLog.lastBackup = time
    BohemkaDKP:UpdateLastBackupInfo()
end
function BohemkaDKP:ProcessLogPayload(data)
    local payload = table.concat(data, "\n")
    local serialized = LibSerialize:Serialize(payload)
    local compressed = LibDeflate:CompressDeflate(serialized)
    return LibDeflate:EncodeForWoWAddonChannel(compressed)
end
function BohemkaDKP:ProcessPayloadToLog(data)
    data = LibDeflate:DecodeForWoWAddonChannel(data)
    data = LibDeflate:DecompressDeflate(data)
    local _, deserialized = LibSerialize:Deserialize(data)
    return {strsplit("\n", deserialized)}
end
function BohemkaDKP:CheckAutoBackup()
    if BohemkaDKPConfig.autoBackup and BohemkaDKPConfig.autoBackup > 0 then
        if not CurrentDKPLog.lastBackup then
            BohemkaDKP:CreateBackup()
        elseif GetServerTime() - CurrentDKPLog.lastBackup > 3600 * BohemkaDKPConfig.autoBackup then
            BohemkaDKP:CreateBackup()
        end
    end

    C_Timer.After(60, function ()
        BohemkaDKP:CheckAutoBackup()
    end)
end
function BohemkaDKP:DeleteBackup(time)
    CurrentDKPLog.backup[time] = nil
    if CurrentDKPLog.lastBackup == time then
        CurrentDKPLog.lastBackup = nil
    end
    BohemkaDKP:UpdateLastBackupInfo()
    BohemkaDKP:Print("Deleted backup from", date('%Y/%m/%d %H:%M', time))
end

function BohemkaDKP:RestoreBackup(time)
    if self:CanRestoreBackup() then
        self:ShareLog(GetServerTime(), "all", 0, 0, "Data restored from-"..time, self:GetPlayerName(true),0, 0, 1)
        BohemkaDKP:Print("Restored backup from", date('%Y/%m/%d %H:%M', time))
    end
end
function BohemkaDKP:CanRestoreBackup()
    return IsGuildLeader()
end

function BohemkaDKP:CanWipeData()
    return IsGuildLeader()
end
BohemkaDKP.syncDone = {}
local syncFrame2 = CreateFrame("Frame")
function BohemkaDKP:InitialSync()
    self:SendEvent("GUILD", self.EVENT.ONLINE_CHECK)
    C_Timer.After(2, function ()
        if #self.onlineChecks == 0 then
            return
        end
        table.sort(self.onlineChecks, function (a, b) return a.onlineSince < b.onlineSince end)
        local mainSource = false
        for _, member in ipairs(self.onlineChecks) do
            if not mainSource and self.onlineSince - member.onlineSince > 300 then
                self:InitSyncFrom(member)
                mainSource = true
            elseif self.onlineSince - member.onlineSince <= 300 then
                self:InitSyncFrom(member)
            end
        end
        table.sort(self.onlineChecks, function (a, b) return a.lastTimeOnline < b.lastTimeOnline end)
        self:LogToChunks(self.onlineChecks[1].lastTimeOnline, function(id, data)
            BohemkaDKP:SendEvent("GUILD", BohemkaDKP.EVENT.PAYLOAD_START, #data, id)
        end)
    end)
end
function BohemkaDKP:InitSyncFrom(member)
    self:Debug("Syncing log from", member)
    self:SyncLogFrom(member.name)
    self.syncDone[member.name] = false
end
function BohemkaDKP:IsSyncFinished()
    local finished = true
    for _, done in pairs(BohemkaDKP.syncDone) do
        if not done then
            finished = false
        end
    end
    return finished
end
function BohemkaDKP:CleanUpLogs()
    for name, data in pairs(CurrentDKPLog.current.data) do
        for time, item in pairs(data) do
            if item.editor == "0" or item.editor == "" then
                CurrentDKPLog.current.data[name][time] = nil
            end
        end
    end
end
